<?
require_once($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/include/prolog_admin_before.php");
require_once($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/sale/include.php");
require_once($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/sale/prolog.php");

$crmMode = (defined("BX_PUBLIC_MODE") && BX_PUBLIC_MODE && isset($_REQUEST["CRM_MANAGER_USER_ID"]));

if ($crmMode)
{
	CUtil::DecodeUriComponent($_GET);
	CUtil::DecodeUriComponent($_POST);
	foreach ($_GET as $key => $val)
	{
		$$key = $val;
	}
	foreach ($_POST as $key => $val)
	{
		$$key = $val;
	}
}

IncludeModuleLangFile(__FILE__);
ClearVars();

$ID = IntVal($ID);

$dbStatusList = CSaleStatus::GetList(
	array("SORT" => "ASC"),
	array("ID" => "N", "LID" => LANGUAGE_ID),
	false,
	false,
	array()
);
$arStatusList = $dbStatusList->Fetch();

$saleModulePermissions = $APPLICATION->GetGroupRight("sale");
if ($saleModulePermissions == "D" OR ($saleModulePermissions < "W" AND $arStatusList["PERM_UPDATE"] != "Y"))
	$APPLICATION->AuthForm(GetMessage("ACCESS_DENIED"));

$errorMessage = "";

/*****************************************************************************/
/********************* ORDER FUNCTIONS ***************************************/
/*****************************************************************************/

/*
 * clean
 */
function CRMModeOutput($text)
{
	while(@ob_end_clean());
	echo $text;
	die();
}

/*
 * user name
 */
function fGetUserName($USER_ID)
{
	$user = "";
	$rsUser = CUser::GetByID($USER_ID);
	$arUser = $rsUser->Fetch();

	if (count($arUser) > 1)
	{
		$user = "(".$arUser["LOGIN"].")";

		if ($arUser["NAME"] != "")
			$user .= " ".$arUser["NAME"];
		if ($arUser["LAST_NAME"] != "")
			$user .= " ".$arUser["LAST_NAME"];
	}

	return $user;
}

/*
 * user property (parameters order)
 */
function fBuyerType($PERSON_TYPE_ID, $USER_ID = '', $ORDER_ID = '', $LID, $lang, $formVarsSubmit)
{
	global $locationZipID, $locationID, $DELIVERY_LOCATION, $DELIVERY_LOCATION_ZIP;

	$userComment = "";
	if ($ORDER_ID > 0)
	{
		$dbOrder = CSaleOrder::GetList(
			array("ID" => "DESC"),
			array("ID" => $ORDER_ID, "ACTIVE" => "Y"),
			false,
			false,
			array()
		);
		$arOrder = $dbOrder->Fetch();
		$userComment = $arOrder["USER_DESCRIPTION"];
	}

	$resultHtml = "<script>locationZipID = '';</script><table width=\"100%\" id=\"order_type_props\" class=\"edit-table\">";

	$arPropValues = array();
	if ($formVarsSubmit)
	{
		$locationIndexForm = "";
		foreach ($_REQUEST as $key => $value)
		{
			if (substr($key, 0, strlen("CITY_ORDER_PROP_")) == "CITY_ORDER_PROP_")
			{
				$arPropValues[IntVal(substr($key, strlen("CITY_ORDER_PROP_")))] = htmlspecialcharsEx($value);
				$locationIndexForm = IntVal(substr($key, strlen("CITY_ORDER_PROP_")));
			}
			if (substr($key, 0, strlen("ORDER_PROP_")) == "ORDER_PROP_")
			{
				if ($locationIndexForm != IntVal(substr($key, strlen("ORDER_PROP_"))))
					$arPropValues[IntVal(substr($key, strlen("ORDER_PROP_")))] = htmlspecialcharsEx($value);
			}
		}
	}
	elseif ($ORDER_ID == "" AND $USER_ID != "")
	{
		//profile
		$userProfile = array();
		$userProfile = CSaleOrderUserProps::DoLoadProfiles($USER_ID, $PERSON_TYPE_ID);
		$arPropValues = $userProfile[$PERSON_TYPE_ID]["VALUES"];
	}
	elseif ($ORDER_ID != "")
	{
		$dbPropValuesList = CSaleOrderPropsValue::GetList(
			array(),
			array("ORDER_ID" => $ORDER_ID, "ACTIVE" => "Y"),
			false,
			false,
			array("ID", "ORDER_PROPS_ID", "NAME", "VALUE", "CODE")
		);
		while ($arPropValuesList = $dbPropValuesList->Fetch())
		{
			$arPropValues[IntVal($arPropValuesList["ORDER_PROPS_ID"])] = $arPropValuesList["VALUE"];
		}
	}

	$dbProperties = CSaleOrderProps::GetList(
		array("GROUP_SORT" => "ASC", "PROPS_GROUP_ID" => "ASC", "SORT" => "ASC", "NAME" => "ASC"),
		array("PERSON_TYPE_ID" => $PERSON_TYPE_ID, "ACTIVE" => "Y"),
		false,
		false,
		array("*")
	);
	$propertyGroupID = -1;

	while ($arProperties = $dbProperties->Fetch())
	{
		if (IntVal($arProperties["PROPS_GROUP_ID"]) != $propertyGroupID)
		{
			$resultHtml .= "<tr class=\"heading\">\n<td colspan=\"2\">".htmlspecialcharsEx($arProperties["GROUP_NAME"])."\n</td>\n</tr>";
			$propertyGroupID = IntVal($arProperties["PROPS_GROUP_ID"]);
		}
		$resultHtml .= "<tr>\n<td align=\"right\" valign=\"top\" class=\"field-name\">\n";

		if ($arProperties["REQUIED"] == "Y" || $arProperties["IS_PROFILE_NAME"] == "Y" || $arProperties["IS_LOCATION"] == "Y" || $arProperties["IS_LOCATION4TAX"] == "Y" || $arProperties["IS_PAYER"] == "Y" || $arProperties["IS_ZIP"] == "Y")
		{
			$resultHtml .= "<span class=\"required\">*</span>";
		}
		$resultHtml .= htmlspecialcharsEx($arProperties["NAME"]).":</td>";

		$curVal = $arPropValues[IntVal($arProperties["ID"])];

		$resultHtml .= "<td align=\"left\">";

		if ($arProperties["TYPE"] == "CHECKBOX")
		{
			$resultHtml .= '<input type="checkbox" class="inputcheckbox" ';
			$resultHtml .= 'name="ORDER_PROP_'.$arProperties["ID"].'" value="Y"';
			$resultHtml .= 'id="ORDER_PROP_'.$arProperties["ID"].'" ';
			if ($curVal=="Y" || !isset($curVal) && $arProperties["DEFAULT_VALUE"]=="Y")
				$resultHtml .= " checked";
			$resultHtml .= '>';
		}
		elseif ($arProperties["TYPE"] == "TEXT")
		{
			$change = "";
			if ($arProperties["IS_ZIP"] == "Y")
			{
				$DELIVERY_LOCATION_ZIP = $curVal;
				$resultHtml .= '<script> locationZipID = \''.$arProperties["ID"].'\';</script>';
				$locationZipID = ((isset($curVal)) ? htmlspecialcharsEx($curVal) : htmlspecialcharsex($arProperties["DEFAULT_VALUE"]));
				//$change = "onChange=\"fRecalcDelivery();\"";
			}
			$resultHtml .= '<input type="text" maxlength="250" ';
			$resultHtml .= 'size="30" ';
			$resultHtml .= 'value="'.((isset($curVal)) ? htmlspecialcharsEx($curVal) : htmlspecialcharsex($arProperties["DEFAULT_VALUE"])).'" ';
			$resultHtml .= 'name="ORDER_PROP_'.$arProperties["ID"].'" ';
			$resultHtml .= 'id="ORDER_PROP_'.$arProperties["ID"].'" '.$change.'>';
		}
		elseif ($arProperties["TYPE"] == "SELECT")
		{
			$resultHtml .= '<select name="ORDER_PROP_'.$arProperties["ID"].'" ';
			$resultHtml .= 'id="ORDER_PROP_'.$arProperties["ID"].'" ';
			$resultHtml .= 'size="5" ';
			$resultHtml .= 'class="typeselect">';
			$dbVariants = CSaleOrderPropsVariant::GetList(
				array("SORT" => "ASC"),
				array("ORDER_PROPS_ID" => $arProperties["ID"]),
				false,
				false,
				array("*")
			);
			while ($arVariants = $dbVariants->Fetch())
			{
				$resultHtml .= '<option value="'.htmlspecialcharsex($arVariants["VALUE"]).'"';
				if ($arVariants["VALUE"] == $curVal || !isset($curVal) && $arVariants["VALUE"] == $arProperties["DEFAULT_VALUE"])
					$resultHtml .= " selected";
				$resultHtml .= '>'.htmlspecialcharsEx($arVariants["NAME"]).'</option>';
			}
			$resultHtml .= '</select>';
		}
		elseif ($arProperties["TYPE"] == "MULTISELECT")
		{
			$resultHtml .= '<select multiple name="ORDER_PROP_'.$arProperties["ID"].'[]" ';
			$resultHtml .= 'id="ORDER_PROP_'.$arProperties["ID"].'" ';
			$resultHtml .= 'size="5" ';
			$resultHtml .= 'class="typeselect" type="multyselect">';

			if (!is_array($curVal))
			{
				if (strlen($curVal) > 0 OR $ORDER_ID != "")
					$curVal = explode(",", $curVal);
				else
					$curVal = explode(",", $arProperties["DEFAULT_VALUE"]);

				$arCurVal = array();
				for ($i = 0; $i < count($curVal); $i++)
					$arCurVal[$i] = Trim($curVal[$i]);
			}
			else
				$arCurVal = $curVal;

			$dbVariants = CSaleOrderPropsVariant::GetList(
				array("SORT" => "ASC"),
				array("ORDER_PROPS_ID" => $arProperties["ID"]),
				false,
				false,
				array("*")
			);
			while ($arVariants = $dbVariants->Fetch())
			{
				$resultHtml .= '<option value="'.htmlspecialcharsex($arVariants["VALUE"]).'"';
				if (in_array($arVariants["VALUE"], $arCurVal))
					$resultHtml .= " selected";
				$resultHtml .= '>'.htmlspecialcharsEx($arVariants["NAME"]).'</option>';
			}
			$resultHtml .= '</select>';
		}
		elseif ($arProperties["TYPE"] == "TEXTAREA")
		{
			$resultHtml .= '<textarea ';
			$resultHtml .= 'rows="4" ';
			$resultHtml .= 'cols="40" ';
			$resultHtml .= 'name="ORDER_PROP_'.$arProperties["ID"].'" ';
			$resultHtml .= 'id="ORDER_PROP_'.$arProperties["ID"].'" type="textarea">';
			$resultHtml .= ((isset($curVal)) ? htmlspecialcharsex($curVal) : htmlspecialcharsex($arProperties["DEFAULT_VALUE"]));
			$resultHtml .= '</textarea>';
		}

		elseif ($arProperties["TYPE"] == "LOCATION")
		{
			$countryID = "";
			$cityID = "";
			$cityList = "";
			$DELIVERY_LOCATION = $arPropValues[IntVal($arProperties["ID"])];

			if (isset($curVal) && $curVal != "")
			{
				$arLocs = CSaleLocation::GetByID($curVal, $lang);
				$countryID = $arLocs["COUNTRY_ID"];
				$cityID = $arLocs["CITY_ID"];
				$cityList = fCityList($countryID, $cityID, $lang, $PERSON_TYPE_ID);
			}
			$locationID = $curVal;

			$resultHtml .= '<script>var locationID = \''.$arProperties["ID"].'\';</script>';
			$resultHtml .= '<select name="ORDER_PROP_'.$arProperties["ID"].'" ';
			$resultHtml .= 'id="ORDER_PROP_'.$arProperties["ID"].'" ';
			$resultHtml .= 'class="typeselect" type="location" onChange="floadCitiesList(this)" >';
			$resultHtml .= '<option';
			if (!isset($curVal) || $curVal == "")
				$resultHtml .= ' selected';
			$resultHtml .= '>'.GetMessage('NEWO_CHOOSE_COUNTRY').'</option>';

			$rsCountryList = CSaleLocation::GetCountryList(array("SORT" => "ASC", "NAME_LANG" => "ASC"));
			while ($arCountry = $rsCountryList->GetNext())
			{
				$resultHtml .= "<option";
				if ($countryID == $arCountry["ID"])
					$resultHtml .= " selected";
				$resultHtml .= " value=\"".$arCountry["ID"]."\">".htmlspecialcharsex($arCountry["NAME"])."</option>";
			}
			$resultHtml .= "</select><span id=\"city_list\">".$cityList."</span>";
			$resultHtml .= "<script>";
			$resultHtml .= "\nfunction floadCitiesList(el)
			{
				var country_id = el.value;
				BX.showWait();
				var buyerType = document.getElementById(\"buyer_type_id\").value;
				BX.ajax.post('/bitrix/admin/sale_order_new.php', '".CUtil::JSEscape(bitrix_sessid_get())."&ORDER_AJAX=Y&buyerttypeid=' + buyerType + '&lang=".$lang."&LID=".$LID."&country_id=' + country_id, floadCitiesListResult);
			}
			function floadCitiesListResult(result)
			{
				BX.closeWait();
				if(result.length > 0)
				{
					document.getElementById('city_list').innerHTML = result;
				}
			}";

			$resultHtml .= "</script>";
		}
		elseif ($arProperties["TYPE"] == "RADIO")
		{
			$dbVariants = CSaleOrderPropsVariant::GetList(
				array("SORT" => "ASC"),
				array("ORDER_PROPS_ID" => $arProperties["ID"]),
				false,
				false,
				array("*")
			);
			$resultHtml .= '<div id="ORDER_PROP_'.$arProperties["ID"].'">';// type="radio"
			while ($arVariants = $dbVariants->Fetch())
			{
				$resultHtml .= '<input type="radio" class="inputradio" ';
				$resultHtml .= 'name="ORDER_PROP_'.$arProperties["ID"].'" ';
				$resultHtml .= 'value="'.htmlspecialcharsex($arVariants["VALUE"]).'"';
				if ($arVariants["VALUE"] == $curVal || !isset($curVal) && $arVariants["VALUE"] == $arProperties["DEFAULT_VALUE"])
					$resultHtml .= " checked";
				$resultHtml .= '>'.htmlspecialcharsEx($arVariants["NAME"]).'<br>';
			}
			$resultHtml .= '</div>';
		}

		if (strlen($arProperties["DESCRIPTION"]) > 0)
		{
			$resultHtml .= "<br><small>".htmlspecialcharsEx($arProperties["DESCRIPTION"])."</small>";
		}
		$resultHtml .= "\n</td>\n</tr>";

	}//end while

	$resultHtml .= "<tr>\n<td width=\"40%\" valign=\"top\" align=\"right\" class=\"field-name\">".GetMessage("SOE_BUYER_COMMENT").":
			</td>
			<td width=\"60%\" valign=\"top\">
				<textarea name=\"USER_DESCRIPTION\" rows=\"4\" cols=\"40\">".$userComment."</textarea>
			</td>
		</tr>";

	$resultHtml .= "</table>";
	return $resultHtml;
}


/*
 * paysystem
 */
function fBuyerDelivery($PERSON_TYPE_ID, $PAY_SYSTEM_ID)
{
	$resultHtml = "<table width=\"100%\">";
	$resultHtml .= "<tr>\n<td width=\"40%\" align=\"right\" class=\"field-name\"><span class=\"required\">*</span>".GetMessage("SOE_PAY_SYSTEM").":</td><td width=\"60%\" align=\"left\">";

	$arPaySystem = CSalePaySystem::DoLoadPaySystems($PERSON_TYPE_ID);


	///// !!!!! -       (    eDost)
//	$resultHtml .= "<select name=\"PAY_SYSTEM_ID\" id=\"PAY_SYSTEM_ID\">\n";
	$resultHtml .= "<select name=\"PAY_SYSTEM_ID\" id=\"PAY_SYSTEM_ID\" onchange=\"fRecalcDelivery();\">\n";
	///// !!!!!


	$resultHtml .= "<option value=\"\">(".GetMessage("SOE_SELECT").")</option>";
	foreach ($arPaySystem as $key => $val)
	{
		$resultHtml .= "<option value=\"".$key."\"";
		if ($key == IntVal($PAY_SYSTEM_ID))
			$resultHtml .= " selected";
		$resultHtml .= ">[".$key."]".$val["NAME"]."</option>";
	}
	$resultHtml .= "</select>";
	$resultHtml .= "</td>\n</tr>";
	$resultHtml .= "</table>";

	return $resultHtml;
}

/*
 * user profile
 */

function fUserProfile($USER_ID, $BUYER_TYPE = '', $default = '')
{
	$userProfileSelect = "<select name=\"user_profile\" id=\"user_profile\" onChange=\"fChangeProfile(this);\">";
	$userProfileSelect .= "<option value=\"0\">".GetMessage("NEWO_BUYER_PROFILE_NEW")."</option>";
	$userProfile = CSaleOrderUserProps::DoLoadProfiles($USER_ID, $BUYER_TYPE);
	$i = "";
	foreach($userProfile as $key => $val)
	{
		if ($default == "" AND $i == "")
		{
			$userProfileSelect .= "<option selected value=\"".$key."\">".$val["NAME"]."</option>";
			$i = $key;
		}
		elseif ($default == $key)
			$userProfileSelect .= "<option selected value=\"".$key."\">".$val["NAME"]."</option>";
		else
			$userProfileSelect .= "<option value=\"".$key."\">".$val["NAME"]."</option>";
	}
	$userProfileSelect .= "</select>";

	return $userProfileSelect;
}

/*
 * city list
 */
function fCityList($countryID, $cityID, $lang, $PERSON_TYPE_ID)
{
	$rsLocationsList = CSaleLocation::GetList(
		array(
			"SORT" => "ASC",
            "COUNTRY_NAME_LANG" => "ASC",
            "CITY_NAME_LANG" => "ASC"
		),
		array(
			"COUNTRY_ID" => $countryID,
			"LID" => $lang,
		),
		false,
		false,
		array(
			"ID", "CITY_ID", "CITY_NAME"
		)
	);
	$arLocation = fGetLocationID($PERSON_TYPE_ID);
	$cityListSelect = "<select name=\"CITY_ORDER_PROP_".$arLocation["LOCATION_ID"]."\" id=\"CITY_ORDER_PROP_".$arLocation["LOCATION_ID"]."\" onChange=\"fRecalcDelivery();\">";
	$cityListSelect .= "<option value=\"\">".GetMessage("NEWO_CHOOSE_CITY")."</option>";
	while ($arCity = $rsLocationsList->GetNext())
	{
		if ($arCity['CITY_ID'] > 0 && $arCity["CITY_NAME"] != "")
		{
			$selected = "";
			if ($arCity["CITY_ID"] == $cityID)
				$selected = "selected";

			$cityListSelect .= "<option ".$selected." value=\"".$arCity["ID"]."\">".$arCity["CITY_NAME"]."</option>";
		}
	}
	$cityListSelect .= "</select>";

	return $cityListSelect;
}

/*
 * user balance
 */
function fGetPayFromAccount($USER_ID, $CURRENCY)
{
	$accountPayDefault = GetMessage("NEWO_PAY_FROM_ACCOUNT_NO");
	$dbUserAccount = CSaleUserAccount::GetList(
	array(),
	array(
		"USER_ID" => $USER_ID,
		"CURRENCY" => $CURRENCY,
		)
	);
	if ($arUserAccount = $dbUserAccount->GetNext())
	{
		if (DoubleVal($arUserAccount["CURRENT_BUDGET"]) > 0)
		{
			$accountPayDefault = SaleFormatCurrency($arUserAccount["CURRENT_BUDGET"], $CURRENCY);
			$accountPayDefault = str_replace("#MONEY#", $accountPayDefault, GetMessage("NEWO_PAY_FROM_ACCOUNT_YES"));
		}
	}

	return $accountPayDefault;
}


/*
 * delivery
 */
///// !!!!! -   : paysystem, persontype, BASKET_ITEMS (  eDost)
//function fGetDelivery($location, $locationZip, $weight, $price, $currency, $siteId, $defaultDelivery)
function fGetDelivery($location, $locationZip, $weight, $price, $currency, $siteId, $defaultDelivery, $edost_paysystem, $edost_persontype, $edost_BASKET_ITEMS)
///// !!!!!
{
	$arResult = array();
	$automatic = "<select name=\"DELIVERY_ID_handler\" id=\"DELIVERY_ID_auto\" OnChange=\"fRecalcDeliveryAuto(this.value)\">";
	$automatic .= "<option value=\"\">(".GetMessage("SOE_NO").")</option>";
	$config = "<select name=\"DELIVERY_ID\" id=\"DELIVERY_ID_conf\" OnChange=\"DeliveryChange(this.value)\">";
	$config .= "<option value=\"\">(".GetMessage("SOE_NO").")</option>";

	$automaticCount = 0;
	$configCount = 0;
	$defautAuto = "";
	$defautConfig = "";

	$arDelivery = CSaleDelivery::DoLoadDelivery($location, $locationZip, $weight, $price, $currency, $siteId);


	///// !!!!! - begin
	//     eDost
	$arPaySys = CSalePaySystem::GetByID($edost_paysystem, $edost_persontype);
	$edost_cod = substr($arPaySys['PSA_ACTION_FILE'], -11) === 'edostpaycod' ? true : false;
	if ($edost_cod) $cod_price = -1;


	//   eDost    (   +        )
	if (substr($defaultDelivery, 0, 6) === 'edost:') $edost_id = substr($defaultDelivery, 6, 3); else $edost_id = -1;

	$delivery_error = array();
//	if (isset($arDelivery['edost'])) unset($arDelivery['edost']);

    $arOrder2 = array(
			"PRICE" => $price,
			"WEIGHT" => $weight,
			"LOCATION_FROM" => COption::GetOptionInt('sale', 'location'),
			"LOCATION_TO" => $location,
			"LOCATION_ZIP" => $locationZip,
			"BASKET_ITEMS" => isset($edost_BASKET_ITEMS) ? $edost_BASKET_ITEMS : '',
			"NO_LOCAL_CACHE" => 'Y',
		);

	$rsDeliveryServicesList = CSaleDeliveryHandler::GetList(array("SORT" => "ASC"), array("COMPABILITY" => $arOrder2));
	while ($arDeliveryService = $rsDeliveryServicesList->Fetch()) {
		if (!is_array($arDeliveryService) || !is_array($arDeliveryService["PROFILES"])) continue;


		//   eDost:   (    )
		if ($arDeliveryService["SID"] != 'edost') {
			foreach ($arDeliveryService["PROFILES"] as $profileId => $arDeliveryProfile)
				if (isset($arDelivery[$arDeliveryService["SID"]]["PROFILES"][$profileId]) && !isset($arDelivery[$arDeliveryService["SID"]]["PROFILES"][$profileId]["DELIVERY_PRICE"])) {
					$arDeliveryPrice = CSaleDeliveryHandler::CalculateFull($arDeliveryService["SID"], $profileId, $arOrder2, $currency);
					if ($arDeliveryPrice["RESULT"] != "OK")
						$delivery_error[] = '['.$arDeliveryService["SID"].':'.$profileId.'] '.$arDeliveryPrice["TEXT"];
				}

			continue;
		}


		//  eDost:  
		$arDelivery[$arDeliveryService["SID"]] = array(
			"SID" => $arDeliveryService["SID"],
			"TITLE" => $arDeliveryService["NAME"],
			"DESCRIPTION" => $arDeliveryService["DESCRIPTION"],
			"PROFILES" => array(),
		);

		if (class_exists(CDeliveryEDOST)) {
			$base_currency = CDeliveryEDOST::GetRUB();
			$warning = CDeliveryEDOST::GetEdostWarning();
			if ($warning != '') $delivery_error[] = $warning;
		}
		else continue;

		foreach ($arDeliveryService["PROFILES"] as $profileId => $arDeliveryProfile) {
			$edost_tariff = CDeliveryEDOST::GetEdostTariff($profileId);

			if (isset($edost_tariff['error']) && $edost_tariff['error'] != '') {
				$delivery_error[] = $edost_tariff['error'];
				$defaultDelivery = '';
				$arResult["DELIVERY_PRICE"] = 0;
				unset($arDelivery['edost']);
				break;
			}

			if ($edost_cod) {
				if ($edost_tariff['pricecash'] == -1) continue;
				else $p = $edost_tariff['pricecash'];
			}
			else $p = $edost_tariff['price'];

			$arDelivery[$arDeliveryService["SID"]]["PROFILES"][$profileId] = array(
				"ID" => $arDeliveryService["SID"].":".$profileId,
				"SID" => $profileId,
				"TITLE" => $arDeliveryProfile["TITLE"],
				"DESCRIPTION" => $arDeliveryProfile["DESCRIPTION"],
				"FIELD_NAME" => "DELIVERY_ID",
				"DELIVERY_PRICE" => roundEx(CCurrencyRates::ConvertCurrency($p, $base_currency, $currency), SALE_VALUE_PRECISION),
				"CURRENCY" => $currency,
			);

			if ($edost_id > 0 && $edost_id == $profileId)
				$arResult["DELIVERY_PRICE"] = $arDelivery[$arDeliveryService["SID"]]["PROFILES"][$profileId]["DELIVERY_PRICE"];
		}
	}
	///// !!!!! - end


	if (count($arDelivery) > 0)
	{
		foreach($arDelivery as $val)
		{
			if (isset($val["PROFILES"]))
			{
				foreach($val["PROFILES"] as $k => $v)
				{
					///// !!!!! -     ,       
					if (!isset($v["DELIVERY_PRICE"])) continue;
					///// !!!!!


					$selected = "";
					if ($v["ID"] == $defaultDelivery)
					{
						$selected = " selected=\"selected\"";
						$defautAuto = $defaultDelivery;
					}


					///// !!!!! -     eDost   
					if ($val["SID"] == 'edost')
						$automatic .= "<option".$selected." value=\"".$v["ID"]."\">".$v["TITLE"].($v["DELIVERY_PRICE"] >= 0 ? ' - '.CurrencyFormat($v["DELIVERY_PRICE"], $currency) : '')."</option>";
					else
					///// !!!!!
						$automatic .= "<option".$selected." value=\"".$v["ID"]."\">[".$v["ID"]."] ".$val["TITLE"]." (".$v["TITLE"].")</option>";


					$automaticCount++;
				}
			}
			else
			{
				$selected = "";
				if ($val["ID"] == $defaultDelivery)
				{
					$selected = " selected=\"selected\"";
					$defautConfig = $defaultDelivery;
				}

				$config .= "<option".$selected." value=\"".$val["ID"]."\">[".$val["ID"]."] ".$val["NAME"]."</option>";
				$configCount++;
			}
		}
	}

	$automatic .= "</select>";
	$config .= "</select>";

	$arResult["DELIVERY_AUTO"] = $automatic;
	$arResult["DELIVERY_AUTO_COUNT"] = $automaticCount;
	$arResult["DELIVERY_AUTO_DEFAULT"] = $defautAuto;
	$arResult["DELIVERY_CONFIG"] = $config;
	$arResult["DELIVERY_CONFIG_COUNT"] = $configCount;
	$arResult["DELIVERY_CONFIG_DEFAULT"] = $defautConfig;


	///// !!!!! -   eDost
	$arResult["delivery_error"] = '';
	foreach ($delivery_error as $key => $error)
		$arResult["delivery_error"] .= ($arResult["delivery_error"] != '' ? '<br>' : '').$error;


//	$arResult["arDelivery"] = $arDelivery;
//	$arResult["arDelivery2222222222"] = array($location, $locationZip, $weight, $price, $currency, $siteId, $delivery_error, $defaultDelivery, $edost_BASKET_ITEMS);
	///// !!!!!


	return $arResult;
}

/*
 * cupons
 */
function fGetCupon($CUPON)
{
	$arCupon = array();
	if (isset($CUPON) AND $CUPON != "")
	{
		$cupons = explode(",", $CUPON);
		foreach($cupons as $val)
		{
			if (strlen(trim($val)) > 0)
				$arCupon[] = trim($val);
		}
	}

	return $arCupon;
}

/*
 * recalc delivery auto
 */
function fGetAutoDelivery($arParams)
{


	///// !!!!! -  
	$arParams["ORDER_PRICE"] = str_replace(' ', '', $arParams["ORDER_PRICE"]);
	$arParams["ORDER_WEIGHT"] = str_replace(' ', '', $arParams["ORDER_WEIGHT"]);
	///// !!!!!


	global $ID;

	$arOrder = CSaleOrder::GetByID($ID);

	$arResult = CSaleDeliveryHandler::CalculateFull(
			$arParams["DELIVERY"],
			$arParams["PROFILE"],
			array(
				"PRICE" => $arParams["ORDER_PRICE"],
				"WEIGHT" => $arParams["ORDER_WEIGHT"],
				"LOCATION_FROM" => COption::GetOptionInt('sale', 'location', '2961', $arParams["LID"]),
				"LOCATION_TO" => $arParams["LOCATION_TO"],
				"LOCATION_ZIP" => $arParams["LOCATION_ZIP"],

				///// !!!!! -    eDost
				"BASKET_ITEMS" => $arParams["BASKET_ITEMS"],
				"NO_LOCAL_CACHE" => 'Y',
				///// !!!!!
			),
			$arParams["CURRENCY"]
	);


	///// !!!!! -     eDost
	$arPaySys = CSalePaySystem::GetByID($arParams["PAY_SYSTEM_ID"], $arParams["PERSON_TYPE_ID"]);
	$edost_cod = substr($arPaySys['PSA_ACTION_FILE'], -11) === 'edostpaycod' ? true : false;
	if ($edost_cod && $arParams["DELIVERY"] == 'edost' && class_exists(CDeliveryEDOST)) {
		$edost_tariff = CDeliveryEDOST::GetEdostTariff($arParams["PROFILE"]);
		if ($edost_tariff['pricecash'] >= 0) $arResult["VALUE"] = $edost_tariff['pricecash'];
	}
	///// !!!!!


	return $arResult;
}

/*
 * get ID, ZIP location
 */
function fGetLocationID($PERSON_TYPE_ID)
{
	$dbProperties = CSaleOrderProps::GetList(
		array("SORT" => "ASC"),
		array("PERSON_TYPE_ID" => $PERSON_TYPE_ID),
		false,
		false,
		array("*")
	);

	$arResult = array();
	while ($arProperties = $dbProperties->Fetch())
	{
		if ($arProperties["TYPE"] == "TEXT")
		{
			if ($arProperties["IS_ZIP"] == "Y")
			{
				$arResult["LOCATION_ZIP_ID"] = $arProperties["ID"];
			}
		}
		elseif ($arProperties["TYPE"] == "LOCATION")
		{
			$arResult["LOCATION_ID"] = $arProperties["ID"];
		}
	}//end while

	return $arResult;
}

/*
 * array product busket
 */
function fGetUserShoppingCart($arProduct, $LID, $currency)
{
	$arOrderProductPrice = array();

	$i = 0;
	foreach($arProduct as $key => $val)
	{
		$val["QUANTITY"] = str_replace(",", ".", $val["QUANTITY"]);
		$val["PRICE"] = str_replace(",", ".", $val["PRICE"]);

		if (!isset($val["BUSKET_ID"]) OR $val["BUSKET_ID"] == "")
		{
			$arOrderProductPrice[$i] = $val;
			$arOrderProductPrice[$i]["LID"] = $LID;
			$arOrderProductPrice[$i]["PRODUCT_ID"] = IntVal($key);
			$arOrderProductPrice[$i]["CAN_BUY"] = "Y";
			$arOrderProductPrice[$i]["CURRENCY"] = $currency;
			if ($val["CALLBACK_FUNC"] == "Y")
			{
				$arOrderProductPrice[$i]["CALLBACK_FUNC"] = '';
				$arOrderProductPrice[$i]["DISCOUNT_PRICE"] = 0;
			}
		}
		else
		{
			$arOrderProductPrice[$i]["ID"] = trim($val["BUSKET_ID"]);
			$arOrderProductPrice[$i]["PRODUCT_ID"] = IntVal($key);
			$arOrderProductPrice[$i]["NAME"] = htmlspecialcharsback($val["NAME"]);
			$arOrderProductPrice[$i]["CAN_BUY"] = "Y";
			$arOrderProductPrice[$i]["PRICE"] = trim($val["PRICE"]);
			$arOrderProductPrice[$i]["NOTES"] = trim($val["NOTES"]);
			$arOrderProductPrice[$i]["CURRENCY"] = trim($val["CURRENCY"]);
			$arOrderProductPrice[$i]["QUANTITY"] = trim($val["QUANTITY"]);
			$arOrderProductPrice[$i]["WEIGHT"] = trim($val["WEIGHT"]);
			$arOrderProductPrice[$i]["VAT_RATE"] = trim($val["VAT_RATE"]);
			$arOrderProductPrice[$i]["DISCOUNT_PRICE"] = trim($val["DISCOUNT_PRICE"]);
			$arOrderProductPrice[$i]["CATALOG_XML_ID"] = trim($val["CATALOG_XML_ID"]);
			$arOrderProductPrice[$i]["PRODUCT_XML_ID"] = trim($val["PRODUCT_XML_ID"]);

		    if ($val["CALLBACK_FUNC"] == "Y")
				$arOrderProductPrice[$i]["DISCOUNT_PRICE"] = 0;

			$arNewProps = array();
			if (is_array($val["PROPS"]))
			{
				foreach($val["PROPS"] as $k => $v)
				{
					if ($v["NAME"] != "" AND $v["VALUE"] != "")
						$arNewProps[$k] = $v;
				}
			}
			else
				$arNewProps = array("NAME" => "", "VALUE" => "", "CODE" => "", "SORT" => "");

			$arOrderProductPrice[$i]["PROPS"] = $arNewProps;
		}
		$i++;
	}//endforeach $arProduct

	return $arOrderProductPrice;
}

/*****************************************************************************/
/**************************** SAVE ORDER *************************************/
/*****************************************************************************/
$bVarsFromForm = false;

if ($REQUEST_METHOD == "POST" && $save_order_data == "Y" && empty($dontsave) AND $saleModulePermissions >= "U" AND check_bitrix_sessid())
{
	$ID = IntVal($ID);

	if (strlen($LID) <= 0)
		$errorMessage .= GetMessage("SOE_EMPTY_SITE")."<br>";

	$currencyDefaultBase = CSaleLang::GetLangCurrency($LID);

	$str_SUM_PAID = DoubleVal(str_replace(",", ".", $SUM_PAID));

	$str_PERSON_TYPE_ID = IntVal($buyer_type_id);
	if ($str_PERSON_TYPE_ID <= 0)
		$errorMessage .= GetMessage("SOE_EMPTY_PERS_TYPE")."<br>";

	if (($str_PERSON_TYPE_ID > 0) && !($arPersonType = CSalePersonType::GetByID($str_PERSON_TYPE_ID)))
		$errorMessage .= GetMessage("SOE_PERSON_NOT_FOUND")."<br>";

	$str_STATUS_ID = trim($STATUS_ID);
	if (strlen($str_STATUS_ID) > 0)
	{
		if ($saleModulePermissions < "W")
		{
			$dbStatusList = CSaleStatus::GetList(
				array(),
				array(
					"GROUP_ID" => $GLOBALS["USER"]->GetUserGroupArray(),
					"PERM_STATUS" => "Y",
					"ID" => $str_STATUS_ID
				),
				array("ID", "MAX" => "PERM_STATUS"),
				false,
				array("ID")
			);
			if (!$dbStatusList->Fetch())
				$errorMessage .= str_replace("#STATUS_ID#", $str_STATUS_ID, GetMessage("SOE_NO_STATUS_PERMS"))."<br>";
		}
	}

	$str_PAY_SYSTEM_ID = IntVal($PAY_SYSTEM_ID);
	if ($str_PAY_SYSTEM_ID <= 0)
		$errorMessage .= GetMessage("SOE_PAYSYS_EMPTY")."<br>";
	if (($str_PAY_SYSTEM_ID > 0) && !($arPaySys = CSalePaySystem::GetByID($str_PAY_SYSTEM_ID, $str_PERSON_TYPE_ID)))
		$errorMessage .= GetMessage("SOE_PAYSYS_NOT_FOUND")."<br>";

	if (count($PRODUCT) <= 0)
		$errorMessage .= GetMessage("SOE_EMPTY_ITEMS")."<br>";

	//delivery
	if (isset($DELIVERY_ID_handler) AND $DELIVERY_ID_handler != "")
	{
		$str_DELIVERY_ID = $DELIVERY_ID_handler;
		$PRICE_DELIVERY = $PRICE_DELIVERY_handler;
	}
	elseif (isset($DELIVERY_ID) AND $DELIVERY_ID != "")
	{
		$str_DELIVERY_ID = IntVal($DELIVERY_ID);
		$PRICE_DELIVERY = $PRICE_DELIVERY;
	}
	//else
	//{
	//	$errorMessage .= GetMessage("SOE_EMPTY_DELIVERY")."<br>";
	//}

	$str_CANCELED = (($CANCELED == "Y") ? "Y" : "N");
	$str_PAYED = (($PAYED == "Y") ? "Y" : "N");
	$str_ALLOW_DELIVERY = (($ALLOW_DELIVERY == "Y") ? "Y" : "N");
	$BASE_LANG_CURRENCY = CSaleLang::GetLangCurrency($LID);

	$arCupon = fGetCupon($CUPON);

	$str_REASON_CANCELED = trim($REASON_CANCELED);

	$str_PAY_VOUCHER_NUM = trim($PAY_VOUCHER_NUM);
	$str_PAY_VOUCHER_DATE = trim($PAY_VOUCHER_DATE);

	$str_DELIVERY_DOC_NUM = trim($DELIVERY_DOC_NUM);
	$str_DELIVERY_DOC_DATE = trim($DELIVERY_DOC_DATE);
	$str_ADDITIONAL_INFO = trim($ADDITIONAL_INFO);
	$str_COMMENTS = $COMMENTS;

	$profileName = "";
	if (isset($user_profile) AND $user_profile != "")
	{
		$userProfileID = IntVal($user_profile);
	}

	//array field send mail
	$rsUser = CUser::GetByID($user_id);
	$arUser = $rsUser->Fetch();
	$FIO = "";
	if ($arUser["LAST_NAME"] != "")
		$FIO .= $arUser["LAST_NAME"]." ";
	if ($arUser["NAME"] != "")
		$FIO .= $arUser["NAME"];

	$arUserEmail = array("PAYER_NAME" => $FIO, "USER_EMAIL" => $arUser["EMAIL"]);


	//create a new user
	if (isset($buyer) AND $buyer == "new_buyer")
	{
		if ($NEW_BUYER_EMAIL == "")
			$errorMessage .= GetMessage("NEWO_BUYER_REG_ERR_MAIL");

		if (strlen($errorMessage) <= 0)
		{
			$userRegister = array(
				"NAME" => $NEW_BUYER_NAME,
				"LAST_NAME" => $NEW_BUYER_LAST_NAME,
				"PERSONAL_MOBILE" => $NEW_BUYER_PHONE
			);

			$arPersonal = array();
			$arPersonal["PERSONAL_MOBILE"] = $NEW_BUYER_PHONE;

			$user_id = CSaleUser::DoAutoRegisterUser($NEW_BUYER_EMAIL, $userRegister, $LID, $arErrors, $arPersonal);
			if (count($arErrors) > 0)
			{
				foreach($arErrors as $val)
				{
					$errorMessage .= $val["TEXT"];
				}
			}
			else
			{
				$userProfileID = 0;
				if (isset($NEW_BUYER_SENDEMAIL) AND $NEW_BUYER_SENDEMAIL == "Y")
				{
					if (count($arUser) <= 0)
					{
						$rsUser = CUser::GetByID($user_id);
						$arUser = $rsUser->Fetch();
					}
					$userNew = str_replace("#FIO#", "(".$arUser["LOGIN"].")".(($arUser["NAME"] != "") ? " ".$arUser["NAME"] : "").(($arUser["LAST_NAME"] != "") ? " ".$arUser["LAST_NAME"] : ""), GetMessage("NEWO_BUYER_REG_OK"));

					CUser::SendUserInfo($user_id, $LID, $userNew, true);
				}
			}
		}
	}

	//property order
	$arOrderPropsValues = array();
	$dbOrderProps = CSaleOrderProps::GetList(
		array("SORT" => "ASC"),
		array("PERSON_TYPE_ID" => $str_PERSON_TYPE_ID, "ACTIVE" => "Y"),
		false,
		false,
		array("ID", "NAME", "TYPE", "REQUIED", "IS_LOCATION", "IS_EMAIL", "IS_PROFILE_NAME", "IS_PAYER", "IS_LOCATION4TAX", "CODE", "SORT")
	);
	while ($arOrderProps = $dbOrderProps->Fetch())
	{
		$curVal = trim(${"ORDER_PROP_".$arOrderProps["ID"]});

		if ($arOrderProps["IS_PAYER"] == "Y")
		{
			$arUserEmail["PAYER_NAME"] = trim($curVal);
		}
		if ($arOrderProps["IS_EMAIL"] == "Y")
		{
			$arUserEmail["USER_EMAIL"] = trim($curVal);
		}

		if ($arOrderProps["IS_PROFILE_NAME"] == "Y")
		{
			$profileName = "";
			if (isset($userProfileID))
			{
				$profileName = $curVal;
			}
		}

		if (
			($arOrderProps["IS_LOCATION"]=="Y" || $arOrderProps["IS_LOCATION4TAX"]=="Y")
			&& IntVal($curVal) <= 0
			||
			($arOrderProps["IS_PROFILE_NAME"]=="Y" || $arOrderProps["IS_PAYER"]=="Y")
			&& strlen($curVal) <= 0
			||
			$arOrderProps["REQUIED"]=="Y"
			&& $arOrderProps["TYPE"]=="LOCATION"
			&& IntVal($curVal) <= 0
			||
			$arOrderProps["REQUIED"]=="Y"
			&& ($arOrderProps["TYPE"]=="TEXT" || $arOrderProps["TYPE"]=="TEXTAREA" || $arOrderProps["TYPE"]=="RADIO" || $arOrderProps["TYPE"]=="SELECT")
			&& strlen($curVal) <= 0
			||
			($arOrderProps["REQUIED"]=="Y"
			&& $arOrderProps["TYPE"]=="MULTISELECT"
			&& strlen($curVal) <= 0)
			)
		{
			$errorMessage .= str_replace("#NAME#", $arOrderProps["NAME"], GetMessage("SOE_EMPTY_PROP"))."<br>";
		}

		if ($arOrderProps["TYPE"] == "MULTISELECT")
		{
			$curVal = "";
			for ($i = 0; $i < count(${"ORDER_PROP_".$arOrderProps["ID"]}); $i++)
			{
				if ($i > 0)
					$curVal .= ",";

				$curVal .= ${"ORDER_PROP_".$arOrderProps["ID"]}[$i];
			}
		}

		if ($arOrderProps["TYPE"]=="LOCATION" && $arOrderProps["IS_LOCATION"] == "Y")
		{
			$curVal = ${"CITY_ORDER_PROP_".$arOrderProps["ID"]};
			$DELIVERY_LOCATION = IntVal($curVal);
		}

		if ($arOrderProps["TYPE"]=="LOCATION" && $arOrderProps["IS_LOCATION4TAX"] == "Y")
		{
			$curVal = ${"CITY_ORDER_PROP_".$arOrderProps["ID"]};
			$TAX_LOCATION = IntVal($curVal);
		}

		$arOrderPropsValues[$arOrderProps["ID"]] = $curVal;
	}


	$str_USER_ID = IntVal($user_id);
	if ($str_USER_ID <= 0)
	{
		$str_USER_ID = "";
		$errorMessage .= GetMessage("SOE_EMPTY_USER")."<br>";
	}
	$rsUser = CUser::GetByID($str_USER_ID);
	if (!$rsUser->Fetch())
		$errorMessage .= GetMessage("NEWO_ERR_EMPTY_USER")."<br>";

	//saving
	if (strlen($errorMessage) <= 0)
	{
		$arShoppingCart = array();
		$arOrderProductPrice = fGetUserShoppingCart($PRODUCT, $LID, $currencyDefaultBase);
		$arShoppingCart = CSaleBasket::DoGetUserShoppingCart($LID, $str_USER_ID, $arOrderProductPrice, $arErrors, $arCupon);
		$arErrors = array();
		$arWarnings = array();

		foreach($arOrderProductPrice as $key => $val)
		{
			if ($val["NAME"] != $arShoppingCart[$key]["NAME"] AND $val["PRODUCT_ID"] == $arShoppingCart[$key]["PRODUCT_ID"])
				$arShoppingCart[$key]["NAME"] = $val["NAME"];

			if ($val["NOTES"] != $arShoppingCart[$key]["NOTES"] AND $val["PRODUCT_ID"] == $arShoppingCart[$key]["PRODUCT_ID"])
				$arShoppingCart[$key]["NOTES"] = $val["NOTES"];
		}

		//parameters order
		$arOrder = CSaleOrder::DoCalculateOrder(
			$LID,
			$str_USER_ID,
			$arShoppingCart,
			$str_PERSON_TYPE_ID,
			$arOrderPropsValues,
			$str_DELIVERY_ID,
			$str_PAY_SYSTEM_ID,
			array(),
			$arErrors,
			$arWarnings);

		//change delivery price
		if (DoubleVal($arOrder["DELIVERY_PRICE"]) != DoubleVal($PRICE_DELIVERY))
		{
			$arOrder["PRICE"] = ($arOrder["PRICE"] - $arOrder["DELIVERY_PRICE"]) + $PRICE_DELIVERY;
			$arOrder["DELIVERY_PRICE"] = $PRICE_DELIVERY;
			$arOrder["PRICE_DELIVERY"] = $PRICE_DELIVERY;
		}

		if (count($arWarnings) > 0)
		{
			foreach ($arWarnings as $val)
			{
				$errorMessage .= $val["TEXT"]."<br>";
			}
		}
		if (count($arErrors) > 0)
		{
			foreach ($arErrors as $val)
			{
				$errorMessage .= $val["TEXT"]."<br>";
			}
		}

	}

	if (strlen($errorMessage) <= 0)
	{
		//another order parametrs
		$arAdditionalFields = array(
			"USER_DESCRIPTION" => $USER_DESCRIPTION,
			"ADDITIONAL_INFO" => $str_ADDITIONAL_INFO,
			"COMMENTS" => $str_COMMENTS,
			"SUM_PAID" => $str_SUM_PAID,
		);

		if (count($arOrder) > 0)
		{
			$arErrors = array();
			$OrderNewSendEmail = false;

			$arOldOrder = CSaleOrder::GetByID($ID);

			if ($ID <= 0 || $arOldOrder["PAYED"] == $str_PAYED)
			{
				$arAdditionalFields["PAYED"] = $str_PAYED;
				$arAdditionalFields["PAY_VOUCHER_NUM"] = ((strlen($str_PAY_VOUCHER_NUM) > 0) ? $str_PAY_VOUCHER_NUM : False);
				$arAdditionalFields["PAY_VOUCHER_DATE"] = ((strlen($str_PAY_VOUCHER_DATE) > 0) ? $str_PAY_VOUCHER_DATE : False);
			}
			if ($ID <= 0 || $arOldOrder["ALLOW_DELIVERY"] == $str_ALLOW_DELIVERY)
			{
				$arAdditionalFields["ALLOW_DELIVERY"] = $str_ALLOW_DELIVERY;
				$arAdditionalFields["DELIVERY_DOC_NUM"] = ((strlen($str_DELIVERY_DOC_NUM) > 0) ? $str_DELIVERY_DOC_NUM : False);
				$arAdditionalFields["DELIVERY_DOC_DATE"] = ((strlen($str_DELIVERY_DOC_DATE) > 0) ? $str_DELIVERY_DOC_DATE : False);
			}
			if ($ID <= 0 || $arOldOrder["CANCELED"] == $str_CANCELED)
			{
				$arAdditionalFields["CANCELED"] = $str_CANCELED;
				$arAdditionalFields["REASON_CANCELED"] = $str_REASON_CANCELED;
			}
			if ($ID <= 0 || $arOldOrder["STATUS_ID"] == $str_STATUS_ID)
			{
				$arAdditionalFields["STATUS_ID"] = $str_STATUS_ID;
			}

			$tmpID = CSaleOrder::DoSaveOrder($arOrder, $arAdditionalFields, $ID, $arErrors, $arCupon);

			if ($ID <= 0)
				$OrderNewSendEmail = true;
			else
			{
				if ($arOldOrder["STATUS_ID"] != $str_STATUS_ID)
					CSaleOrder::StatusOrder($ID, $str_STATUS_ID);

				if ($arOldOrder["CANCELED"] != $str_CANCELED)
					CSaleOrder::CancelOrder($ID, $str_CANCELED, $str_REASON_CANCELED);

				if ($arOldOrder["PAYED"] != $str_PAYED)
				{
					$arFieldsPay = array(
						"PAY_VOUCHER_NUM" => ((strlen($str_PAY_VOUCHER_NUM) > 0) ? $str_PAY_VOUCHER_NUM : False),
						"PAY_VOUCHER_DATE" => ((strlen($str_PAY_VOUCHER_DATE) > 0) ? $str_PAY_VOUCHER_DATE : False)
					);
					CSaleOrder::PayOrder($ID, $str_PAYED, false, false, 0, $arFieldsPay);
				}

				if ($arOldOrder["ALLOW_DELIVERY"] != $str_ALLOW_DELIVERY)
				{
					$arFieldsDelivery = array(
						"DELIVERY_DOC_NUM" => ((strlen($str_DELIVERY_DOC_NUM) > 0) ? $str_DELIVERY_DOC_NUM : False),
						"DELIVERY_DOC_DATE" => ((strlen($str_DELIVERY_DOC_DATE) > 0) ? $str_DELIVERY_DOC_DATE : False),
					);
					CSaleOrder::DeliverOrder($ID, $str_ALLOW_DELIVERY, 0, $arFieldsDelivery);
				}
			}

			$ID = $tmpID;

			//payed user account
			if ($ID > 0 AND count($arErrors) <= 0 AND isset($PAY_CURRENT_ACCOUNT) AND $PAY_CURRENT_ACCOUNT == "Y")
			{
				if ($arOrder["PRICE"] > $str_SUM_PAID)
				{
					$DB->StartTransaction();
					$arOrderUser = CSaleOrder::GetByID($ID);
					//pay back
					if (CSaleUserAccount::UpdateAccount($str_USER_ID, $arOrderUser["SUM_PAID"], $currencyDefaultBase, "Payed order ".$ID, $ID))
					{
						if (!CSaleUserAccount::DoPayOrderFromAccount($str_USER_ID, $currencyDefaultBase, $ID, $arOrder["PRICE"], array(), $arErrors))
						{
							$errorMessage .= GetMessage("NEWO_PAY_FROM_ACCOUNT_ERR")."<br>";
						}
					}
					else
					{
						$errorMessage .= GetMessage("NEWO_PAY_FROM_ACCOUNT_ERR")."<br>";
					}
					if (strlen($errorMessage) == 0)
						$DB->Commit();
					else
						$DB->Rollback();
				}
				else
				{
					$errorMessage .= GetMessage("NEWO_PAY_FROM_ACCOUNT_PAYED")."<br>";
				}
			}

			if ($ID > 0 AND count($arErrors) <= 0)
			{
				//profile saving
				$str_USER_ID = IntVal($str_USER_ID);

				if (isset($userProfileID))
				{
					CSaleOrderUserProps::DoSaveUserProfile($str_USER_ID, $userProfileID, $profileName, $str_PERSON_TYPE_ID, $arOrderPropsValues, $arErrors);
				}
				unset($user_profile);
				//send new order mail
				if ($OrderNewSendEmail)
				{
					$strOrderList = "";
					foreach ($arOrder["BASKET_ITEMS"] as $val)
					{
						$strOrderList .= $val["NAME"]." - ".$val["QUANTITY"]." ".GetMessage("SOA_SHT").": ".SaleFormatCurrency($val["PRICE"], $currencyDefaultBase);
						$strOrderList .= "\n";
					}

					//send mail
					$arFields = Array(
						"ORDER_ID" => $ID,
						"ORDER_DATE" => Date($DB->DateFormatToPHP(CLang::GetDateFormat("SHORT", $LID))),
						"ORDER_USER" => $arUserEmail["PAYER_NAME"],
						"PRICE" => SaleFormatCurrency($arOrder["PRICE"], $currencyDefaultBase),
						"BCC" => COption::GetOptionString("sale", "order_email", "order@".$SERVER_NAME),
						"EMAIL" => $arUserEmail["USER_EMAIL"],
						"ORDER_LIST" => $strOrderList,
						"SALE_EMAIL" => COption::GetOptionString("sale", "order_email", "order@".$SERVER_NAME),
						"DELIVERY_PRICE" => $arOrder["DELIVERY_PRICE"],
					);
					$eventName = "SALE_NEW_ORDER";

					$bSend = true;
					$db_events = GetModuleEvents("sale", "OnOrderNewSendEmail");
					while ($arEvent = $db_events->Fetch())
						if (ExecuteModuleEventEx($arEvent, Array($ID, &$eventName, &$arFields))===false)
							$bSend = false;

					if($bSend)
					{
						$event = new CEvent;
						$event->Send($eventName, $LID, $arFields, "N");
					}
				}
			}
			else
			{
				foreach($arErrors as $val)
				{
					$errorMessage .= $val["TEXT"]."<br>";
				}
			}

		}
		elseif (count($arErrors) > 0)
		{
			foreach($arErrors as $val)
			{
				$errorMessage .= $val["TEXT"]."<br>";
			}
		}
		else
		{
			$errorMessage .= GetMessage("SOE_SAVE_ERROR")."<br>";
		}
	}//end if save

	unset($location);
	unset($BTN_SAVE_BUYER);
	unset($buyertypechange);
	unset($userId);
	unset($user_id);

	if (strlen($errorMessage) <= 0 AND $ID > 0)
	{
		if ($crmMode)
			CRMModeOutput($ID);

		if (isset($save) AND strlen($save) > 0)
		{
			CSaleOrder::UnLock($ID);
			LocalRedirect("/bitrix/admin/sale_order.php?lang=".LANG);
		}
	}
	if (strlen($errorMessage) > 0)
	{
		$bVarsFromForm = true;
		//if ($crmMode)
		//	CRMModeOutput($errorMessage);
	}
}

if (!empty($dontsave))
{
	CSaleOrder::UnLock($ID);
	if ($crmMode)
		CRMModeOutput($ID);

	LocalRedirect("/bitrix/admin/sale_order.php?lang=".LANG.GetFilterParams("filter_", false));
}

/*****************************************************************************/
/************** Processing of requests from the proxy ************************/
/*****************************************************************************/

if (isset($ORDER_AJAX) AND $ORDER_AJAX == "Y" AND check_bitrix_sessid())
{
	/*
	* mestopolojenie
	*/
	if (isset($location) AND !isset($product) AND !isset($locationZip))
	{
		$location = IntVal($location);
		$arData = array();

		$arLocs = CSaleLocation::GetByID($location, $lang);
		$countryID = $arLocs["COUNTRY_ID"];
		$cityID = $arLocs["CITY_ID"];

		$arData["status"] = "ok";
		$arData["propid"] = $locid;
		$arData["countryid"] = $countryID;
		$arData["citylist"] = fCityList($countryID, $cityID, $lang, $propID);

		$result = CUtil::PhpToJSObject($arData);

		CRMModeOutput($result);
	}

	/*
	* sample of cities
	*/
	if (isset($country_id))
	{
		$country_id = IntVal($country_id);
		$buyerttypeid = IntVal($buyerttypeid);

		CRMModeOutput(fCityList($country_id, '', $lang, $buyerttypeid));
	}

	/*
	* change type buyer
	*/
	if (isset($buyertypechange))
	{
		if (!isset($ID) OR $ID == "") $ID = "";
		if (!isset($paysystemid) OR $paysystemid == "") $paysystemid = "";

		$arData = array();
		$arData["status"] = "ok";
		$arData["buyertype"] = fBuyerType($buyertypechange, $userId, $ID, $LID, $lang);
		$arData["buyerdelivery"] = fBuyerDelivery($buyertypechange, $paysystemid);
		$arLocation = fGetLocationID($buyertypechange);

		$arData["location_id"] = $arLocation["LOCATION_ID"];
		$arData["location_zip_id"] = $arLocation["LOCATION_ZIP_ID"];

		$result = CUtil::PhpToJSObject($arData);

		CRMModeOutput($result);
	}

	/*
	* get locationId for geting delivery
	*/
	if (isset($persontypeid))
	{
		$persontypeid = IntVal($persontypeid);

		$arData = array();
		$arLocation = fGetLocationID($persontypeid);

		$arData["location_id"] = $arLocation["LOCATION_ID"];
		$arData["location_zip_id"] = $arLocation["LOCATION_ZIP_ID"];

		$result = CUtil::PhpToJSObject($arData);

		CRMModeOutput($result);
	}

	/*
	* take a list profile
	*/
	if (isset($userId) AND isset($buyerType) AND (!isset($profileDefault) OR $profileDefault == ""))
	{
		$userId = IntVal($userId);
		$buyerType = IntVal($buyerType);
		$arData = array();

		$arData["status"] = "ok";
		$arData["userProfileSelect"] = fUserProfile($userId, $buyerType);
		$arData["userName"] = fGetUserName($userId);

		$result = CUtil::PhpToJSObject($arData);

		CRMModeOutput($result);
	}

	/*
	* script autocomplite profile
	*/
	if (isset($userId) AND isset($buyerType) AND isset($profileDefault))
	{
		$userId = IntVal($userId);
		$buyerType = IntVal($buyerType);
		$profileDefault = IntVal($profileDefault);

		$userProfile = array();
		$userProfile = CSaleOrderUserProps::DoLoadProfiles($userId, $buyerType);
		if ($profileDefault != "" AND $profileDefault != "0")
			$arPropValues = $userProfile[$profileDefault]["VALUES"];

		$dbVariants = CSaleOrderProps::GetList(
			array("SORT" => "ASC"),
			array(
					"PERSON_TYPE_ID" => $buyerType,
					"USER_PROPS" => "Y",
					"ACTIVE" => "Y"
				),
			false,
			false,
			array()
		);
		while ($arVariants = $dbVariants->GetNext())
		{
			if (!isset($arPropValues[$arVariants["ID"]]))
			{
				$arPropValues[$arVariants["ID"]] = "";
			}
		}

		$scriptExec = "<script language=\"JavaScript\">";
		foreach ($arPropValues as $key => $val):
			$scriptExec .= "var el = document.getElementById(\"ORDER_PROP_".$key."\");\n";
			$scriptExec .= "var elType = el.getAttribute('type');\n";
			$scriptExec .= "if (elType == \"text\" || elType == \"textarea\" || elType == \"select\")\n";
			$scriptExec .= "{";
				$scriptExec .= "el.value = '".$val."';\n";
			$scriptExec .= "}";
			$scriptExec .= "else if (elType == \"location\")\n";
			$scriptExec .= "{";
				$scriptExec .= "BX.ajax.post('/bitrix/admin/sale_order_new.php', '".CUtil::JSEscape(bitrix_sessid_get())."&ORDER_AJAX=Y&locid=".$key."&propID=".$buyerType."&LID=".$LID."&location=".$val."', fLocationResult);\n";
			$scriptExec .= "}";
			$scriptExec .= "else if (elType == \"radio\")\n";
			$scriptExec .= "{";
				$scriptExec .= "elRadio = el.getElementsByTagName(\"input\");\n";
				$scriptExec .= "for (var i = 0; i < elRadio.length; i++)\n";
				$scriptExec .= "{";
					$scriptExec .= "if (elRadio[i].value == '".$val."')\n";
					$scriptExec .= "{";
						$scriptExec .= "elRadio[i].checked = true;\n";
					$scriptExec .= "}";
					$scriptExec .= "else {";
						$scriptExec .= "elRadio[i].checked = false;\n";
					$scriptExec .= "}";
				$scriptExec .= "}";
			$scriptExec .= "}";
			$scriptExec .= "else if (elType == \"checkbox\")\n";
			$scriptExec .= "{";
				if ($val == "Y")
				{
					$scriptExec .= "el.checked = true;\n";
				}
				else
				{
					$scriptExec .= "el.checked = false;\n";
				}
			$scriptExec .= "}";
			$scriptExec .= "else if (elType == \"multyselect\")\n";
			$scriptExec .= "{";
				if ($val != "")
				{
					$selectedVal = explode(",", $val);
					foreach ($selectedVal as $k => $v):
						$scriptExec .= "el.value = '".trim($v)."';\n";
					endforeach;
				}
				else
				{
					$scriptExec .= "el.selectedIndex = -1;";
				}
			$scriptExec .= "}\n";
		endforeach;
		$scriptExec .= "fRecalcDelivery();</script>";

		echo $scriptExec;
		die();
	}

	/*
	* recal order
	*/
	if (isset($product) AND isset($user_id))
	{
		$result = "";
		$userId = IntVal($userId);
		$paySystemId = IntVal($paySystemId);
		$buyerTypeId = IntVal($buyerTypeId);
		$location = IntVal($location);
		$locationID = IntVal($locationID);
		$locationZip = IntVal($locationZip);
		$locationZipID = IntVal($locationZipID);

		$arOrderProduct = CUtil::JsObjectToPhp($product);

		$arCupon = fGetCupon($cupon);
		$arOrderProductPrice = fGetUserShoppingCart($arOrderProduct, $LID, $currency);
		$arShoppingCart = CSaleBasket::DoGetUserShoppingCart($LID, $user_id, $arOrderProductPrice, $arErrors, $arCupon);

		$arOrderPropsValues = array();
		if ($locationID != "" AND $location != "")
			$arOrderPropsValues[$locationID] = $location;
		if ($locationZipID != "" AND $locationZip != "")
			$arOrderPropsValues[$locationZipID] = $locationZip;

		$arOrder = CSaleOrder::DoCalculateOrder(
			$LID,
			$user_id,
			$arShoppingCart,
			$buyerTypeId,
			$arOrderPropsValues,
			$deliveryId,
			$paySystemId,
			array(),
			$arErrors,
			$arWarnings);

		$orderPrice = $arOrder["PRICE"];
		//change delivery price
		///// !!!!! -     (   )
//		if (DoubleVal($arOrder["DELIVERY_PRICE"]) != DoubleVal($deliveryPrice))
		if (DoubleVal($arOrder["DELIVERY_PRICE"]) != DoubleVal($deliveryPrice) && DoubleVal($deliveryPrice) >= 0)
		///// !!!!!
		{
			$arOrder["PRICE"] = ($arOrder["PRICE"] - $arOrder["DELIVERY_PRICE"]) + $deliveryPrice;
			$arOrder["DELIVERY_PRICE"] = $deliveryPrice;
			$arOrder["PRICE_DELIVERY"] = $deliveryPrice;
		}

		$countTotal = 0;
		$arData = array();
		foreach ($arOrder["BASKET_ITEMS"] as $val)
		{
			$arData[$val["PRODUCT_ID"]]["PRICE"] = $val["PRICE"];
			$arData[$val["PRODUCT_ID"]]["QUANTITY"] = $val["QUANTITY"];
			$arData[$val["PRODUCT_ID"]]["DISCOUNT_PRICE_DISPLAY"] = CurrencyFormatNumber($val["DISCOUNT_PRICE"], $val["CURRENCY"]);
			$arData[$val["PRODUCT_ID"]]["SUMMA_DISPLAY"] = CurrencyFormatNumber(($val["PRICE"] * $val["QUANTITY"]), $val["CURRENCY"]);
			$arCurFormat = CCurrencyLang::GetCurrencyFormat($val["CURRENCY"]);
			$arData[$val["PRODUCT_ID"]]["CURRENCY_FORMAT"] = str_replace("#", '', $arCurFormat["FORMAT_STRING"]);

			$countTotal += $val["QUANTITY"];
		}
		if (!isset($arOrder["ORDER_PRICE"]) OR $arOrder["ORDER_PRICE"] == "" )
			$arOrder["ORDER_PRICE"] = 0;
		if (!isset($arOrder["PRICE"]) OR $arOrder["PRICE"] == "")
			$arOrder["PRICE"] = 0;
		if (!isset($arOrder["DISCOUNT_VALUE"]) OR $arOrder["DISCOUNT_VALUE"] == "")
			$arOrder["DISCOUNT_VALUE"] = 0;

		$WEIGHT_UNIT = htmlspecialchars(COption::GetOptionString('sale', 'weight_unit', "", $LID));
		$WEIGHT_KOEF = htmlspecialchars(COption::GetOptionString('sale', 'weight_koef', 1, $LID));

		$arData[0]["COUNT_TOTAL"] = DoubleVal($countTotal);
		$arData[0]["PRICE_TOTAL"] = CurrencyFormatNumber($arOrder["PRICE"], $currency);
		$arData[0]["PRICE_TOTAL_DISPLAY"] = SaleFormatCurrency($arOrder["PRICE"], $currency);
		$arData[0]["WEIGHT_DISPLAY"] = roundEx(DoubleVal($arOrder["ORDER_WEIGHT"]/$WEIGHT_KOEF), SALE_VALUE_PRECISION)." ".$WEIGHT_UNIT;
		$arData[0]["WEIGHT_TOTAL"] = roundEx(DoubleVal($arOrder["ORDER_WEIGHT"]/$WEIGHT_KOEF), SALE_VALUE_PRECISION);
		$arData[0]["DISCOUNT_VALUE_DISPLAY"] = SaleFormatCurrency($arOrder["DISCOUNT_VALUE"], $currency);
		$arData[0]["VAT_DISPLAY"] = SaleFormatCurrency(DoubleVal($arOrder["TAX_VALUE"]), $currency);

		$arData[0]["PAY_ACCOUNT"] = fGetPayFromAccount($user_id, $currency);


		//delivery
		///// !!!!! -   eDost,     
//		$orderDelivery = fGetDelivery($location, $locationZip, $arOrder["ORDER_WEIGHT"], $orderPrice, $currency, $LID, $deliveryId);
		$orderDelivery = fGetDelivery($location, $locationZip, $arOrder["ORDER_WEIGHT"], $arOrder["PRICE"], $currency, $LID, $deliveryId, $paySystemId, IntVal($buyerTypeId), $arOrder["BASKET_ITEMS"]);

		//    eDost
		if (isset($orderDelivery["DELIVERY_PRICE"]) && $orderDelivery["DELIVERY_PRICE"] >= 0 && DoubleVal($deliveryPrice) < 0) {
			$arOrder["PRICE"] = ($arOrder["PRICE"] - $arOrder["DELIVERY_PRICE"]) + $orderDelivery["DELIVERY_PRICE"];
			$arOrder["DELIVERY_PRICE"] = $orderDelivery["DELIVERY_PRICE"];
			$arOrder["PRICE_DELIVERY"] = $deliveryPrice;

			$arData[0]["PRICE_TOTAL"] = CurrencyFormatNumber($arOrder["PRICE"], $currency);
			$arData[0]["PRICE_TOTAL_DISPLAY"] = SaleFormatCurrency($arOrder["PRICE"], $currency);
        }

		//       ""
		$arData[0]["DELIVERY_TOTAL"] = str_replace(' ', '', CurrencyFormatNumber($arOrder["DELIVERY_PRICE"], $currency));
		$arData[0]["DELIVERY_TOTAL_DISPLAY"] = SaleFormatCurrency(DoubleVal($arOrder["DELIVERY_PRICE"]), $currency);

		$arData[0]["ORDER_PRICE"] = $arOrder["ORDER_PRICE"];
		$arData[0]["WEIGHT_TOTAL"] = $arOrder["ORDER_WEIGHT"];

		$arData[0]["delivery_error"] = $orderDelivery["delivery_error"];


//		$arData[0]["DELIVERY_TOTAL_22222_arOrder"] = $arOrder;
//		$arData[0]["DELIVERY_TOTAL_22222_orderDelivery"] = $orderDelivery;
		///// !!!!!


		$arData[0]["DELIVERY_AUTO"] = $orderDelivery["DELIVERY_AUTO"];
		$arData[0]["DELIVERY_CONFIG"] = $orderDelivery["DELIVERY_CONFIG"];
		$arData[0]["DELIVERY_AUTO_DEFAULT"] = $orderDelivery["DELIVERY_AUTO_DEFAULT"];
		$arData[0]["DELIVERY_CONFIG_DEFAULT"] = $orderDelivery["DELIVERY_CONFIG_DEFAULT"];

		$result = CUtil::PhpToJSObject($arData);

		CRMModeOutput($result);
	}


	/*
	* get a list delivery
	*/
	if (isset($location) AND isset($locationZip) AND isset($user_id))
	{
		$userId = IntVal($userId);
		$location = IntVal($location);
		$locationZip = IntVal($locationZip);

		// !!!!!!!!!!!!!!!!
		$orderDelivery = fGetDelivery($location, $locationZip, $weight, $price, $currency, $LID, $deliveryid);

		$arData["DELIVERY_AUTO"] = $orderDelivery["DELIVERY_AUTO"];
		$arData["DELIVERY_AUTO_DEFAULT"] = $orderDelivery["DELIVERY_AUTO_DEFAULT"];
		$arData["DELIVERY_CONFIG"] = $orderDelivery["DELIVERY_CONFIG"];
		$arData["DELIVERY_CONFIG_DEFAULT"] = $orderDelivery["DELIVERY_CONFIG_DEFAULT"];

		$result = CUtil::PhpToJSObject($arData);

		CRMModeOutput($result);
	}

	/*
	* recalc auto delivery
	*/
	if (isset($recalcDeliverAuto) AND $recalcDeliverAuto != "")
	{
		$arParams = CUtil::JsObjectToPhp($recalcDeliverAuto);
		$ID = $arParams["ID"];
		$arData = fGetAutoDelivery($arParams);
		$result = CUtil::PhpToJSObject($arData);

		CRMModeOutput($result);
	}
}//end ORDER_AJAX=Y


/*****************************************************************************/
/**************************** FORM ORDER *************************************/
/*****************************************************************************/

//date order
$str_DATE_UPDATE = Date(CDatabase::DateFormatToPHP(CLang::GetDateFormat("FULL", $lang)));
$str_DATE_INSERT = Date(CDatabase::DateFormatToPHP(CLang::GetDateFormat("FULL", $lang)));
$str_PRICE = 0;
$str_DISCOUNT_VALUE = 0;

if (isset($ID) && $ID > 0)
{
	$dbOrder = CSaleOrder::GetList(
		array("ID" => "DESC"),
		array("ID" => $ID),
		false,
		false,
		array()
	);
	//$ar_sales = $dbOrder->Fetch();
	//print_r($ar_sales);die();
	if (!($arOrderOldTmp = $dbOrder->ExtractFields("str_")))
		LocalRedirect("sale_order.php?lang=".LANG.GetFilterParams("filter_", false));

	$LID = $str_LID;
}
if (!isset($str_TAX_VALUE) OR $str_TAX_VALUE == "")
	$str_TAX_VALUE = 0;


/*
 * form select site
 */
if ((!isset($LID) OR $LID == "") AND (defined('BX_PUBLIC_MODE') OR BX_PUBLIC_MODE == 1) )
{
	$arSitesShop = array();
	$arSitesTmp = array();
	$rsSites = CSite::GetList($by="id", $order="asc", Array("ACTIVE" => "Y"));
	while ($arSite = $rsSites->Fetch())
	{
		$site = COption::GetOptionString("sale", "SHOP_SITE_".$arSite["ID"], "");
		if ($arSite["ID"] == $site)
		{
			$arSitesShop[] = array("ID" => $arSite["ID"], "NAME" => $arSite["NAME"]);
		}
		$arSitesTmp[] = array("ID" => $arSite["ID"], "NAME" => $arSite["NAME"]);
	}

	$rsCount = count($arSitesShop);
	if ($rsCount <= 0)
	{
		$arSitesShop = $arSitesTmp;
		$rsCount = count($arSitesShop);
	}

	if ($rsCount === 1)
	{
		$LID = $arSitesShop[0]["ID"];
	}
	elseif ($rsCount > 1)
	{
?>
		<div id="select_lid">
			<form action="" name="select_lid">
				<div style="margin:10px auto;text-align:center;">
					<div><?=GetMessage("NEWO_SELECT_SITE")?></div><br />
					<select name="LID" onChange="fLidChange(this);">
						<option selected="selected" value=""><?=GetMessage("NEWO_SELECT_SITE")?></option>
						<?
						foreach ($arSitesShop as $key => $val)
						{
						?>
							<option value="<?=$val["ID"]?>"><? echo $val["NAME"]." (".$val["ID"].")";?></option>
						<?
						}
						?>
					</select>
				</div>
				<script>
					function fLidChange(el)
					{
						BX.showWait();
						BX.ajax.post("/bitrix/admin/sale_order_new.php", "<?=CUtil::JSEscape(bitrix_sessid_get())?>&ORDER_AJAX=Y&lang=<?=LANGUAGE_ID?>&LID=" + el.value, fLidChangeResult);
					}
					function fLidChangeResult(result)
					{
						fLidChangeDisableButtons(false);
						BX.closeWait();
						if (result.length > 0)
						{
							document.getElementById("select_lid").innerHTML = result;
						}
					}
					function fLidChangeDisableButtons(val)
					{
						var btn = document.getElementById("btn-save");
						if (btn)
							btn.disabled = val;
						btn = document.getElementById("btn-cancel");
						if (btn)
							btn.disabled = val;
					}
					BX.ready(function(){ fLidChangeDisableButtons(true); });
				</script>
			</form>
		</div>
<?
		die();
	}
	else
	{
		echo "<div style=\"margin:10px auto;text-align:center;\">";
		echo GetMessage("NEWO_NO_SITE_SELECT");
		echo "<div>";
		die();
	}
}

if (!isset($str_CURRENCY) OR $str_CURRENCY == "")
	$str_CURRENCY = CSaleLang::GetLangCurrency($LID);

$aTabs = array(
	array("DIV" => "edit1", "TAB" => GetMessage("SOEN_TAB_ORDER"), "ICON" => "sale", "TITLE" => GetMessage("SOEN_TAB_ORDER_DESCR")),
	array("DIV" => "edit2", "TAB" => GetMessage("SOEN_TAB_BASKET"), "ICON" => "sale", "TITLE" => GetMessage("SOEN_TAB_BASKET_DESCR")),
	array("DIV" => "edit3", "TAB" => GetMessage("SOE_TAB_PROPS"), "ICON" => "sale", "TITLE" => GetMessage("SOE_TAB_PROPS_DESCR")),
	array("DIV" => "edit4", "TAB" => GetMessage("SOE_TAB_PAY_DEL"), "ICON" => "sale", "TITLE" => GetMessage("SOE_TAB_PAY_DEL_DESCR")),
	array("DIV" => "edit5", "TAB" => GetMessage("SOE_TAB_COMMENT"), "ICON" => "sale", "TITLE" => GetMessage("SOE_TAB_COMMENT_DESCR")),
);
$tabControl = new CAdminForm("form_order", $aTabs, false, $crmMode);

if (isset($ID) && $ID > 0)
	$APPLICATION->SetTitle(str_replace("#ID#", $ID, GetMessage("NEWO_TITLE_EDIT")));
elseif (isset($LID) && $LID != "")
	$APPLICATION->SetTitle(str_replace("#LID#", $LID, GetMessage("NEWO_TITLE_ADD")));
else
	$APPLICATION->SetTitle(GetMessage("NEWO_TITLE_DEFAULT"));

require($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/include/prolog_admin_after.php");

$aMenu = array();
$aMenu = array(
	array(
		"TEXT" => GetMessage("SOE_TO_LIST"),
		"LINK" => "/bitrix/admin/sale_order.php?lang=".LANGUAGE_ID
	)
);
$link = urlencode(DeleteParam(array("mode")));
$link = urlencode($GLOBALS["APPLICATION"]->GetCurPage())."?mode=settings".($link <> "" ? "&".$link: "");
$aMenu[] = array(
	"TEXT"=>GetMessage("NEWO_CUSTOM_FIELD"),
	"TITLE"=>GetMessage("NEWO_CUSTOM_FIELD_TITLE"),
	"LINK"=>"javascript:".$tabControl->GetName().".ShowSettings('".htmlspecialchars(CUtil::addslashes($link))."')",
	"ICON"=>"btn_settings",
);


//delete context menu for remote query
if (!defined('BX_PUBLIC_MODE') || BX_PUBLIC_MODE != 1)
{
	$context = new CAdminContextMenu($aMenu);
	$context->Show();
}


/*********************************************************************/
/********************  BODY  *****************************************/
/*********************************************************************/

CAdminMessage::ShowMessage($errorMessage);

$tabControl->BeginEpilogContent();
?>

<?=bitrix_sessid_post();?>
<input type="hidden" name="lang" value="<?=LANGUAGE_ID?>">
<input type="hidden" name="LID" value="<?=$LID?>">
<input type="hidden" name="ID" value="<?=$ID?>">
<input type="hidden" name="save_order_data" value="Y">
<?
$tabControl->EndEpilogContent();

$urlForm = "";
if (isset($ID) AND $ID != "")
{
	$urlForm = "&ID=".$ID;
	CSaleOrder::Lock($ID);
}
$tabControl->Begin(array(
		"FORM_ACTION" => $APPLICATION->GetCurPage()."?lang=".LANG.$urlForm
));

//TAB ORDER
$tabControl->BeginNextFormTab();

$tabControl->AddSection("ORDER_BUYER_TITLE", GetMessage("SOE_ORDER_BUYER_TITLE"));

$tabControl->BeginCustomField("USER_ID", GetMessage("NEWO_BUYER"), true);
?>
	<tr>
		<td width="40%" valign="top"><?=GetMessage("NEWO_BUYER")?>:</td>
		<td width="60%">

			<input <? if (!$bVarsFromForm OR $buyer != "new_buyer") {echo "checked";}   ?> type="radio" name="buyer" value="select_buyer" id="select_buyer" onClick="fBuyerSelect();" /><label for="select_buyer"><?=GetMessage("NEWO_BUYER_SELECT")?></label>&nbsp;&nbsp;

			<input <? if ($bVarsFromForm AND $buyer == "new_buyer") {echo "checked";}   ?> type="radio" name="buyer" value="new_buyer" id="new_user" onClick="fBuyerSelect();" /><label for="new_user"><?=GetMessage("NEWO_BUYER_NEW")?></label>

			<div id="select_buyer_form" <? if ($bVarsFromForm AND $buyer == "new_buyer") {echo "style=\"display:none;\"";} ?>   >
				<br />
				<input type="text" name="user_id" id="user_id" size="3" value="<?=$str_USER_ID;?>" onChange="fUserGetProfile(this);" >
				<input type="button" name="BTN_USER_SELECT" value="..." onClick="window.open('/bitrix/admin/user_search.php?lang=<?=$lang?>&FN=form_order_form&FC=user_id', '', 'scrollbars=yes,resizable=yes,width=760,height=500,top='+Math.floor((screen.height - 560)/2-14)+',left='+Math.floor((screen.width - 760)/2-5));" >
				<span id="user_name">&nbsp;&nbsp;<?=fGetUserName($str_USER_ID)?></span>

				<script>
					var locationID = 0;
					var locationZipID = 0;

					function fUserGetProfile(el)
					{
						var userId = el.value;
						var buyerType = document.getElementById("buyer_type_id").value;
						document.getElementById("buyer_profile_display").style.display = "none";

						if (userId != "" && buyerType != "")
						{
							BX.showWait();
							BX.ajax.post('/bitrix/admin/sale_order_new.php', '<?=CUtil::JSEscape(bitrix_sessid_get())?>&ORDER_AJAX=Y&LID=<?=$LID?>&userId=' + userId + '&buyerType=' + buyerType, fUserGetProfileResult);
						}
					}
					function fUserGetProfileResult(res)
					{
						var rs = eval( '('+res+')' );
						if (rs["status"] == "ok")
						{
							BX.closeWait();
							document.getElementById("buyer_profile_display").style.display = "table-row";
							document.getElementById("buyer_profile_select").innerHTML = rs["userProfileSelect"];
							document.getElementById("user_name").innerHTML = rs["userName"];

							var profile = document.getElementById("user_profile");
							fChangeProfile(profile);
						}
						else
						{
							BX.closeWait();
						}
					}

					function fGetExecScript(userId, buyerType, profileDefault)
					{
						BX.ajax({
							url: '/bitrix/admin/sale_order_new.php',
							method: 'POST',
							data : '<?=CUtil::JSEscape(bitrix_sessid_get())?>&ORDER_AJAX=Y&LID=<?=$LID?>&userId=' + userId + '&buyerType=' + buyerType + '&profileDefault=' + profileDefault,
							dataType: 'html',
							timeout: 10,
							async: true,
							processData: true,
							scriptsRunFirst: true,
							emulateOnload: true,
							start: true,
							cache: false
						});
						BX.closeWait();
					}
				</script>
			</div>

			<div id="new_buyer_form" <? if ($bVarsFromForm AND $buyer == "new_buyer") { ?> style="display:block;" <? } else { ?> style="display:none;" <? } ?> >
				<div id="buyer_registr">
					<div id="error_buyer" style="color:red">&nbsp;</div>
					<table cellspacing="5" cellpadding="0">
						<tr>
							<td width="70" align="left"><span class="required">*</span><?=GetMessage("NEWO_BUYER_REG_MAIL")?></td>
							<td align="left"><input type="text" name="NEW_BUYER_EMAIL" id="userNewMail" value="<?=$NEW_BUYER_EMAIL?>" tabindex="1" /></td>
						</tr>
						<tr>
							<td width="70" align="left"><?=GetMessage("NEWO_BUYER_REG_MAIL_SEND")?></td>
							<td align="left"><input type="checkbox" checked name="NEW_BUYER_SENDEMAIL" id="userNewMailSend" value="Y" tabindex="2" /></td>
						</tr>
						<tr>
							<td><?=GetMessage("NEWO_BUYER_REG_NAME")?></td>
							<td align="left"><input type="text" name="NEW_BUYER_NAME" id="userNewName" value="<?=$NEW_BUYER_NAME?>" tabindex="3" /></td>
						</tr>
						<tr>
							<td><?=GetMessage("NEWO_BUYER_REG_LASTNAME")?></td>
							<td align="left"><input type="text" name="NEW_BUYER_LAST_NAME" id="userNewLastName" value="<?=$NEW_BUYER_LAST_NAME?>" tabindex="4" /></td>
						</tr>
						<tr>
							<td><?=GetMessage("NEWO_BUYER_REG_PHONE")?></td>
							<td align="left"><input type="text" name="NEW_BUYER_PHONE" id="userPhone" value="<?=$NEW_BUYER_PHONE?>" tabindex="5" /></td>
						</tr>
					</table>
				</div>
			</div>

			<script language="JavaScript">
				function fBuyerSelect()
				{
					radioGroupObj = document.form_order_form.buyer;
					for (var i = 0; i < radioGroupObj.length; i++)
					{
						if (radioGroupObj[i].checked)
						{
							document.getElementById(radioGroupObj[i].value + "_form").style.display = "block";
						}
						else
						{
							document.getElementById(radioGroupObj[i].value + "_form").style.display = "none";
						}
					}
				}
				</script>
		</td>
	</tr>
<?
$tabControl->EndCustomField("USER_ID");

$tabControl->AddSection("ORDER_TITLE", GetMessage("SOE_ORDER_TITLE"));

$tabControl->BeginCustomField("ORDER_DATE_CREATE", GetMessage("SOE_ORDER_HEAD"), true);
if ($ID > 0)
{
?>
<tr>
		<td width="40%"><?=GetMessage("SOE_ORDER_HEAD")?>:</td>
		<td width="60%"><?=str_replace("#ID#", $ID, str_replace("#DATE#", $str_DATE_INSERT, GetMessage("SOE_ORDER_TBL_HEAD")));?></td>
</tr>
<?
}
$tabControl->EndCustomField("ORDER_DATE_CREATE");


$tabControl->BeginCustomField("DATE_ORDER", GetMessage("SOE_DATE_UPDATE"), true);
if ($ID > 0)
{
?>
<tr>
		<td width="40%"><?=GetMessage("SOE_DATE_UPDATE")?>:</td>
		<td width="60%"><?=$str_DATE_UPDATE;?></td>
</tr>
<?
}
$tabControl->EndCustomField("DATE_ORDER");


$rsSites = CSite::GetList($by="id", $order="asc", Array("ID" => $LID, "ACTIVE" => "Y"));
$arSite = $rsSites->Fetch();
if (!isset($LID) OR $LID == "")
	$LID = $arSite["LID"];
$tabControl->AddViewField("LID", GetMessage("SOE_SITE").":", $arSite["NAME"]." (".$arSite["ID"].")", true);

$tabControl->BeginCustomField("ORDER_STATUS", GetMessage("SOE_STATUS"), true);
?>
	<tr>
		<td width="40%">
			<span class="required">*</span><?=GetMessage("SOE_STATUS")?>:
		</td>
		<td width="60%">
			<?
			$arFilter = array("LID" => LANGUAGE_ID);
			$arGroupByTmp = false;

			if ($saleModulePermissions < "W")
			{
				$arFilter["GROUP_ID"] = $GLOBALS["USER"]->GetUserGroupArray();
				$arFilter["PERM_STATUS_FROM"] = "Y";
				if (strlen($str_STATUS_ID) > 0)
					$arFilter["ID"] = $str_STATUS_ID;
				$arGroupByTmp = array("ID", "NAME", "MAX" => "PERM_STATUS_FROM");
			}
			$dbStatusList = CSaleStatus::GetList(
				array(),
				$arFilter,
				$arGroupByTmp,
				false,
				array("ID", "NAME", "SORT")
			);

			if ($dbStatusList->GetNext())
			{
			?>
				<select name="STATUS_ID" id="STATUS_ID">
					<?
					$arFilter = array("LID" => LANG);
					$arGroupByTmp = false;
					if ($saleModulePermissions < "W")
					{
						$arFilter["GROUP_ID"] = $GLOBALS["USER"]->GetUserGroupArray();
						$arFilter["PERM_STATUS"] = "Y";
					}
					$dbStatusListTmp = CSaleStatus::GetList(
						array("SORT" => "ASC"),
						$arFilter,
						$arGroupByTmp,
						false,
						array("ID", "NAME", "SORT")
					);
					while($arStatusListTmp = $dbStatusListTmp->GetNext())
					{
						?><option value="<?echo $arStatusListTmp["ID"] ?>"<?if ($arStatusListTmp["ID"]==$str_STATUS_ID) echo " selected"?>>[<?echo $arStatusListTmp["ID"] ?>] <?echo $arStatusListTmp["NAME"] ?></option><?
					}
					?>
				</select>
				<?
			}
			else
			{
				$arStatusLand = CSaleStatus::GetLangByID($str_STATUS_ID, LANGUAGE_ID);
				echo htmlspecialcharsEx("[".$str_STATUS_ID."] ".$arStatusLand["NAME"]);
			}
			?>
		</td>
	</tr>
<?
$tabControl->EndCustomField("ORDER_STATUS");

$tabControl->BeginCustomField("ORDER_SUM", GetMessage("SOE_SUM"), true);
?>
<tr>
	<td width="40%"><?=GetMessage("SOE_SUM")?>:</td>
	<td width="60%">
		<div id="ITOG_ORDER_SUM"><?=SaleFormatCurrency($str_PRICE, $str_CURRENCY)?></div>
	</td>
</tr>
<?
$tabControl->EndCustomField("ORDER_SUM");

$tabControl->BeginCustomField("ALREADY_PAID", GetMessage("SOE_ALREADY_PAID"), true);
?>
<tr>
	<td width="40%"><?=GetMessage("SOE_ALREADY_PAID")?>:</td>
	<td width="60%">
		<?
		$arCurFormat = CCurrencyLang::GetCurrencyFormat($str_CURRENCY);
		$currencyEd = str_replace("#", '', $arCurFormat["FORMAT_STRING"]);
		?>
		<input type="text" name="SUM_PAID" size="10" maxlength="20" value="<?=roundEx($str_SUM_PAID, SALE_VALUE_PRECISION)?>">
		<span id="SUM_PAID_CURRENCY" class="tablebodytext"><?=$currencyEd?></span>
	</td>
</tr>
<?
$tabControl->EndCustomField("ALREADY_PAID");

$tabControl->BeginCustomField("CANCELED", GetMessage("SOE_CANCELED"), true);
if ($ID > 0)
{
	$checket = "";
	if ($str_CANCELED == "Y")
		$checket = "checked";
	?>
	<tr>
		<td width="40%"><?=GetMessage("SOE_CANCELED")?></td>
		<td width="60%">
			<input type="checkbox" name="CANCELED" value="Y" <?=$checket?> />
		</td>
	</tr>
	<?
}
$tabControl->EndCustomField("CANCELED");

$tabControl->BeginCustomField("REASON_CANCELED", GetMessage("SOE_CANCEL_REASON"), true);
if ($ID > 0)
{
	?>
	<tr>
		<td width="40%"><?=GetMessage("SOE_CANCEL_REASON")?>:</td>
		<td width="60%">
			<textarea name="REASON_CANCELED" rows="4" cols="30"><?=$str_REASON_CANCELED?></textarea>
		</td>
	</tr>
	<?
}
$tabControl->EndCustomField("REASON_CANCELED");

//TAB COMPOZITE ORDER
$tabControl->BeginNextFormTab();

$tabControl->BeginCustomField("DICKOUNT_CUPON", GetMessage("NEWO_BASKET_CUPON"), true);
?>
<tr>
	<td align="left" class="field-name" width="40%" valign="top"><div style="margin-top:3px;"><?=GetMessage("NEWO_BASKET_CUPON")?>:</div></td>
	<td align="left">
		<input type="text" name="CUPON" id="CUPON" value="<?=$CUPON?>" />
		<a href="javascript:void(0)" onClick="fRecalProduct('', '');"><?=GetMessage("NEWO_CUPON_RECALC")?></a>
		<div><?=GetMessage("NEWO_CUPON_DESC")?></div>
		<div><?=GetMessage("NEWO_CUPON_NEW_DESC")?></div>
	</td>
</tr>
<?
$tabControl->EndCustomField("DICKOUNT_CUPON");

$tabControl->BeginCustomField("BASKET_CONTAINER", GetMessage("NEWO_BASKET_CONTAINER"), true);
?>
	<tr>
		<td colspan="2" id="ID_BASKET_CONTAINER">
			<script language="JavaScript">
				var arProduct = [];
				var arProductProperty = [];
				var arProductEditCountProps = [];
			</script>
			<?
			$arCurFormat = CCurrencyLang::GetCurrencyFormat($str_CURRENCY);
			$CURRENCY_FORMAT = trim(str_replace("#", '', $arCurFormat["FORMAT_STRING"]));
			?>
			<table cellpadding="3" cellspacing="1" border="0" width="100%" class="internal" id="BASKET_TABLE">
				<tr class="heading">
					<td><?echo GetMessage("SALE_F_NAME")?></td>
					<td><?echo GetMessage("SALE_F_PTYPE")?></td>
					<td><?echo GetMessage("SALE_F_PROPS")?></td>
					<td><?echo GetMessage("SALE_F_QUANTITY")?></td>
					<td><?echo GetMessage("SALE_F_PRICE")?> (<?=$CURRENCY_FORMAT?>)</td>
					<td><?echo GetMessage("SALE_F_DISCOUNT")?> (<?=$CURRENCY_FORMAT?>)</td>
					<td><?echo GetMessage("SALE_F_SUMMA")?> (<?=$CURRENCY_FORMAT?>)</td>
					<td>&nbsp;</td>
				</tr>
	<?
	$arBasketItem = array();
	if ((isset($PRODUCT) AND count($PRODUCT) > 0) AND $bVarsFromForm)
	{
		foreach ($PRODUCT as $key => $val)
		{
			$val["PRODUCT_ID"] = $key;
			$arBasketItem[] = $val;
		}
	}
	elseif (isset($ID) AND $ID > 0)
	{
		$dbBasket = CSaleBasket::GetList(
			array("ID" => "ASC"),
			array("ORDER_ID" => $ID),
			false,
			false,
			array("ID", "PRODUCT_ID", "PRODUCT_PRICE_ID", "PRICE", "CURRENCY", "WEIGHT", "QUANTITY", "NAME", "MODULE", "CALLBACK_FUNC", "NOTES", "DETAIL_PAGE_URL", "DISCOUNT_PRICE", "ORDER_CALLBACK_FUNC", "CANCEL_CALLBACK_FUNC", "PAY_CALLBACK_FUNC", "CATALOG_XML_ID", "PRODUCT_XML_ID", "VAT_RATE")
		);
		while ($arBasket = $dbBasket->GetNext())
		{
			$arBasket["PROPS"] = Array();
			$dbBasketProps = CSaleBasket::GetPropsList(
					array("SORT" => "ASC", "NAME" => "ASC"),
					array("BASKET_ID" => $arBasket["ID"]),
					false,
					false,
					array("ID", "BASKET_ID", "NAME", "VALUE", "CODE", "SORT")
				);
			while ($arBasketProps = $dbBasketProps->GetNext())
			{
				$arBasket["PROPS"][$arBasketProps["ID"]] = $arBasketProps;
			}

			$arBasketItem[$arBasket["ID"]] = $arBasket;
		}
	}

	$productCountAll = 0;
	$productWeight = 0;
	$WEIGHT_UNIT = htmlspecialchars(COption::GetOptionString('sale', 'weight_unit', "", $LID));
	$WEIGHT_KOEF = htmlspecialchars(COption::GetOptionString('sale', 'weight_koef', 1, $LID));

	$QUANTITY_FACTORIAL = COption::GetOptionString('sale', 'QUANTITY_FACTORIAL', "N");
	if (!isset($QUANTITY_FACTORIAL) OR $QUANTITY_FACTORIAL == "")
		$QUANTITY_FACTORIAL = 'N';

	//edit form props
	$formTemplate = '
				<input id="FORM_BASKET_PRODUCT_ID" name="BASKET_PRODUCT_ID" value="" type="hidden">
				<table class="edit-table" style="background-color:#F8F9FC; border: 1px solid #B8C1DD; width: 600px;" >
				<tr class="heading" style="background-color:#E0E4F1;color:#525355;font-weight:bold;text-align:center;">
					<td colspan="2" align="center">
					<table width="100%">
					<tr>
						<td align="center">'.GetMessage("SOE_BASKET_EDIT").'</td>
						<td width="10"><a href="javascript:void(0);" onClick="SaleBasketEditTool.PopupHide();" style="color:#525355;float:right;margin-right:5px;font-weight:normal;text-decoration:none;font-size:12px;">&times;<a></td>
					</tr>
					</table>
					</td>
				</tr>
				<tr>
					<td width="40%">&nbsp;</td>
					<td align="left" width="60%">
					<div id="basketError" style="display:none;">
						<table class="message message-error" border="0" cellpadding="0" cellspacing="0" style="border:2px solid #FF0000;color:#FF0000">
							<tr>
								<td>
									<table class="content" border="0" cellpadding="0" cellspacing="0" style="margin:4px;">
										<tr>
											<td valign="top"><div class="icon-error"></div></td>
											<td>
												<span class="message-title" style="font-weight:bold;">'.GetMessage("SOE_BASKET_ERROR").'</span><br>
												<div class="empty" style="height: 5px;"></div><div id="basketErrorText"></div>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</div></td>
				</tr>
				<tr id="FORM_NEWPROD_CODE">
					<td class="field-name" align="right"><span class="required">*</span>'.GetMessage("SOE_ITEM_ID").':</td>
					<td><input size="10" id="FORM_PROD_BASKET_ID" name="FORM_PROD_BASKET_ID" type="text" value="" tabindex="1"></td>
				</tr>
				<tr>
					<td class="field-name" align="right"><span class="required">*</span>'.GetMessage("SOE_ITEM_NAME").':</td>
					<td><input size="40" id="FORM_PROD_BASKET_NAME" name="FORM_PROD_BASKET_NAME" type="text" value="" tabindex="2"></td>
				</tr>
				<tr>
					<td class="field-name" align="right">'.GetMessage("SOE_ITEM_PATH").':</td>
					<td><input id="FORM_PROD_BASKET_DETAIL_URL" name="FORM_BASKET_CATALOG_XML_ID" value="" size="40" type="text" tabindex="3"></td>
				</tr>
				<tr>
					<td class="field-name" align="right">'.GetMessage("SOE_BASKET_CATALOG_XML").':</td>
					<td><input id="FORM_BASKET_CATALOG_XML" name="FORM_BASKET_CATALOG_XML" value="" size="40" type="text" tabindex="4"></td>
				</tr>
				<tr>
					<td class="field-name" align="right">'.GetMessage("SOE_BASKET_PRODUCT_XML").':</td>
					<td><input id="FORM_PROD_BASKET_PRODUCT_XML" name="FORM_PROD_BASKET_PRODUCT_XML" value="" size="40" type="text" tabindex="5"></td>
				</tr>
				<tr>
					<td class="field-name" align="right">'.GetMessage("SOE_ITEM_DESCR").':</td>
					<td><input name="FORM_PROD_BASKET_NOTES" id="FORM_PROD_BASKET_NOTES" size="40" maxlength="250" value="" type="text" tabindex="6"></td>
				</tr>
				<tr>
					<td class="field-name" align="right" valign="top" width="40%">'.GetMessage("SOE_ITEM_PROPS").':</td>
					<td width="60%">
						<table id="BASKET_PROP_TABLE" class="internal" border="0" cellpadding="3" cellspacing="1" style="width: 390px;">
							<tr class="heading" style="border-collapse:collapse;background-color:#E7EAF5;color:#525355;">
								<td align="center"><span class="required">*</span>'.GetMessage("SOE_IP_NAME").'</td>
								<td align="center"><span class="required">*</span>'.GetMessage("SOE_IP_VALUE").'</td>
								<td align="center">'.GetMessage("SOE_IP_CODE").'</td>
								<td align="center">'.GetMessage("SOE_IP_SORT").'</td>
							</tr>
						</table>

						<input value="'.GetMessage("SOE_PROPERTY_MORE").'" onclick="BasketAddPropSection()" type="button">
					</td>
				</tr>
				<tr>
					<td class="field-name" align="right">'.GetMessage("SALE_F_QUANTITY").':</td>
					<td><input name="FORM_PROD_BASKET_QUANTITY" id="FORM_PROD_BASKET_QUANTITY" size="10" maxlength="20" value="1" type="text" tabindex="7"></td>
				</tr>
				<tr>
					<td class="field-name" align="right">'.GetMessage("SALE_F_PRICE").':</td>
					<td><input name="FORM_PROD_BASKET_PRICE" id="FORM_PROD_BASKET_PRICE" size="10" maxlength="20" value="1" type="text" tabindex="8"> ('.$CURRENCY_FORMAT.')</td>
				</tr>
				<tr>
					<td class="field-name" align="right">'.GetMessage("SOE_WEIGHT").':</td>
					<td><input name="FORM_PROD_BASKET_WEIGHT" id="FORM_PROD_BASKET_WEIGHT" size="10" maxlength="20" value="0" type="text" tabindex="9"> ('.GetMessage("SOE_GRAMM").')</td>
				</tr>
				<tr>
					<td colspan="2" align="center"><input name="btn1" value="'.GetMessage("SOE_APPLY").'" onclick="SaveProduct();" type="button"> <input name="btn2" value="'.GetMessage("SALE_CANCEL").'" onclick="SaleBasketEditTool.PopupHide();" type="button"></td>
				</tr>
				</table>';
	$formTemplate = CUtil::JSEscape($formTemplate);

	foreach($arBasketItem as $val)
	{
		if (!$crmMode)
		{
			$rsProductInfo = CIBlockElement::GetByID($val["PRODUCT_ID"]);
			$arProductInfo = $rsProductInfo->GetNext();
		}
		$productImg = "";

		if($arProductInfo["PREVIEW_PICTURE"] != "")
			$productImg = $arProductInfo["PREVIEW_PICTURE"];
		elseif($arProductInfo["DETAIL_PICTURE"] != "")
			$productImg = $arProductInfo["DETAIL_PICTURE"];

		if ($productImg != "")
		{
			$arFile = CFile::GetFileArray($productImg);
			$productImg = CFile::ResizeImageGet($arFile, array('width'=>50, 'height'=>50), BX_RESIZE_IMAGE_PROPORTIONAL, false, false);
			$val["PICTURE"] = $productImg;
		}

		$propsProd = "";
		$countProp = 0;
		if (is_array($val["PROPS"]))
		{
			foreach($val["PROPS"] as $valProd)
			{
				$countProp++;
				$propsProd .= "<input type=\"hidden\" name=\"PRODUCT[".$val["PRODUCT_ID"]."][PROPS][".$countProp."][NAME]\" id=\"PRODUCT_PROPS_NAME_".$val["PRODUCT_ID"]."_".$countProp."\" value=\"".$valProd["NAME"]."\" />";
				$propsProd .= "<input type=\"hidden\" name=\"PRODUCT[".$val["PRODUCT_ID"]."][PROPS][".$countProp."][VALUE]\" id=\"PRODUCT_PROPS_VALUE_".$val["PRODUCT_ID"]."_".$countProp."\" value=\"".$valProd["VALUE"]."\" />";
				$propsProd .= "<input type=\"hidden\" name=\"PRODUCT[".$val["PRODUCT_ID"]."][PROPS][".$countProp."][CODE]\" id=\"PRODUCT_PROPS_CODE_".$val["PRODUCT_ID"]."_".$countProp."\" value=\"".$valProd["CODE"]."\" />";
				$propsProd .= "<input type=\"hidden\" name=\"PRODUCT[".$val["PRODUCT_ID"]."][PROPS][".$countProp."][SORT]\" id=\"PRODUCT_PROPS_SORT_".$val["PRODUCT_ID"]."_".$countProp."\" value=\"".$valProd["SORT"]."\" />";
			}
		}
		$val["QUANTITY"] = $QUANTITY_FACTORIAL == 'Y' ? FloatVal($val["QUANTITY"]) : IntVal($val["QUANTITY"]);

		$productCountAll += $val["QUANTITY"];
		$productWeight += ($val["WEIGHT"] * $val["QUANTITY"]);
	?>
		<tr id="BASKET_TABLE_ROW_<?=$val["PRODUCT_ID"]?>">
			<td>
				<table border="0">
				<tr>
				<? if (is_array($val["PICTURE"])):?>
					<td valign="top" align="left">
					<img src="<?=$val["PICTURE"]["src"]?>" alt="" width="50" style="float:left;margin:3px;" />
					</td>
				<?endif?>
				<td align="left" valign="middle">
					<div id="product_name_<?=$val["PRODUCT_ID"]?>"><?=trim($val["NAME"])?></div>
				</td>
				</tr>
				</table>
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][ID]"                   id="BUSKET_<?=$val["ID"]?>" value="<?=$val["ID"]?>" />
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][CURRENCY]"             id="CURRENCY_<?=$val["PRODUCT_ID"]?>" value="<?=$val["CURRENCY"]?>" />
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][BUSKET_ID]"            id="BUSKET_<?=$val["PRODUCT_ID"]?>" value="<?=$val["ID"]?>" />
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][CALLBACK_FUNC]"        id="CALLBACK_FUNC_<?=$val["PRODUCT_ID"]?>" value="<?=$val["CALLBACK_FUNC"]?>" />
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][ORDER_CALLBACK_FUNC]"  id="ORDER_CALLBACK_FUNC_<?=$val["PRODUCT_ID"]?>" value="<?=$val["ORDER_CALLBACK_FUNC"]?>" />
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][CANCEL_CALLBACK_FUNC]" id="CANCEL_CALLBACK_FUNC_<?=$val["PRODUCT_ID"]?>" value="<?=$val["CANCEL_CALLBACK_FUNC"]?>" />
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][PAY_CALLBACK_FUNC]"    id="PAY_CALLBACK_FUNC_<?=$val["PRODUCT_ID"]?>" value="<?=$val["PAY_CALLBACK_FUNC"]?>" />
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][DISCOUNT_PRICE]"       id="PRODUCT[<?=$val["PRODUCT_ID"]?>][DISCOUNT_PRICE]" value="<?=$val["DISCOUNT_PRICE"]?>" >
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][VAT_RATE]"             id="PRODUCT[<?=$val["PRODUCT_ID"]?>][VAT_RATE]" value="<?=$val["VAT_RATE"]?>" >
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][WEIGHT]"               id="PRODUCT[<?=$val["PRODUCT_ID"]?>][WEIGHT]" value="<?=$val["WEIGHT"]?>" />
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][MODULE]"               id="PRODUCT[<?=$val["PRODUCT_ID"]?>][MODULE]" value="<?=$val["MODULE"]?>" />
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][NOTES]"                id="PRODUCT[<?=$val["PRODUCT_ID"]?>][NOTES]" value="<?=$val["NOTES"]?>" />
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][CATALOG_XML_ID]"       id="PRODUCT[<?=$val["PRODUCT_ID"]?>][CATALOG_XML_ID]" value="<?=$val["CATALOG_XML_ID"]?>" >
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][PRODUCT_XML_ID]"       id="PRODUCT[<?=$val["PRODUCT_ID"]?>][PRODUCT_XML_ID]" value="<?=$val["PRODUCT_XML_ID"]?>" />
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][MODULE]"               id="PRODUCT[<?=$val["PRODUCT_ID"]?>][MODULE]" value="<?=$val["MODULE"]?>" />
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][DETAIL_PAGE_URL]"      id="PRODUCT[<?=$val["PRODUCT_ID"]?>][DETAIL_PAGE_URL]" value="<?=$val["DETAIL_PAGE_URL"]?>" />
				<input type="hidden" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][NAME]"                 id="PRODUCT[<?=$val["PRODUCT_ID"]?>][NAME]" value="<?=  htmlspecialchars($val["NAME"])?>" />

				<span id="product_props_<?=$val["PRODUCT_ID"]?>"><?=$propsProd?></span>
				<script language="JavaScript">
				<!--
					arProduct[<?=$val["PRODUCT_ID"]?>] = '<?=$val["PRODUCT_ID"]?>';
					arProductEditCountProps[<?=$val["PRODUCT_ID"]?>] = <?=$countProp?>;
				-->
				</script>
			</td>
			<td><div id="product_notes_<?=$val["PRODUCT_ID"]?>"><?=$val["NOTES"]?></div></td>
			<td><div id="PRODUCT_PROPS_USER_<?=$val["PRODUCT_ID"]?>">
				<?
				if (is_array($val["PROPS"]))
				{
					foreach($val["PROPS"] as $vv)
					{
						if(strlen($vv["VALUE"]) > 0)
							echo $vv["NAME"].": ".$vv["VALUE"]."<br />";
					}
				}
				?>
			</div></td>

			<td align="center" id="DIV_QUANTITY_<?=$val["PRODUCT_ID"]?>">
			<div>
				<input onChange="fRecalProduct(<?=$val["PRODUCT_ID"]?>, '');" type="text" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][QUANTITY]" id="PRODUCT[<?=$val["PRODUCT_ID"]?>][QUANTITY]" value="<?=$val["QUANTITY"]?>" size="4" >
			</div>
			</td>
			<td align="center" id="DIV_PRICE_<?=$val["PRODUCT_ID"]?>">
			<div>
				<input onChange="fRecalProduct(<?=$val["PRODUCT_ID"]?>, 'price');" type="text" name="PRODUCT[<?=$val["PRODUCT_ID"]?>][PRICE]" id="PRODUCT[<?=$val["PRODUCT_ID"]?>][PRICE]" value="<?=FloatVal($val["PRICE"])?>" size="10" >
			</div>
			</td>
			<td align="right" id="DIV_DISCOUNT_<?=$val["PRODUCT_ID"]?>">
				<div><?=CurrencyFormatNumber($val["DISCOUNT_PRICE"], $str_CURRENCY);?></div>
			</td>
 			<td align="right" id="DIV_SUMMA_<?=$val["PRODUCT_ID"]?>">
				<div><?=CurrencyFormatNumber(($val["QUANTITY"] * $val["PRICE"]), $str_CURRENCY);?></div>
			</td>
			<td align="center">
				<div>
					<a href="javascript:void(0)" onClick="ShowProductEdit(<?=$val["PRODUCT_ID"]?>);"><?=GetMessage("SOE_JS_EDIT")?></a><br />
					<a href="javascript:void(0)" onClick="DeleteProduct(this, <?=$val["PRODUCT_ID"]?>);"><?=GetMessage("SOE_JS_DEL")?></a>
				</div>
			</td>
		</tr>
	<?
	}//end foreach $arBasketItem
	?>
	<tr style="font-weight:bold">
		<td>
			<div><?echo GetMessage("SALE_F_WEIGHT")?></div>
			<div><?echo GetMessage("SOE_DISCOUNT")?></div>
			<div><?echo GetMessage("SALE_F_NALOGI")?></div>


			<?/* ///// !!!!! -   " "  "" */?>
			<div><?echo GetMessage("SOE_DELIVERY_PRICE")?></div>
			<?/* ///// !!!!! */?>


			<div><?echo GetMessage("SALE_F_ITOG")?></div>
		</td>
		<td>&nbsp;</a></td>
		<td>&nbsp;</td>
		<td align="center" valign="bottom" id="PRODUCT_COUNT_ALL"><div><?=$productCountAll?></div></td>
		<td>&nbsp;</td>
		<td>&nbsp;</td>
		<td align="right" valign="bottom" nowrap>
			<div id="PRODUCT_WAIGHT_ALL">
				<div>
				<?=roundEx(DoubleVal($productWeight/$WEIGHT_KOEF), SALE_VALUE_PRECISION)." ".$WEIGHT_UNIT;?>
				</div>
			</div>
			<div id="DISCOUNT_SHOP_ALL">
				<div>
				<?=SaleFormatCurrency($str_DISCOUNT_VALUE, $str_CURRENCY);?>
				</div>
			</div>
			<div id="PRODUCT_VAT_ALL">
				<div>
				<?=SaleFormatCurrency($str_TAX_VALUE, $str_CURRENCY);?>
				</div>
			</div>


			<?/* ///// !!!!! -   " "  "" */?>
			<div id="DELIVERY_ALL">
				<div>
					<?=SaleFormatCurrency($str_PRICE_DELIVERY, $str_CURRENCY);?>
				</div>
			</div>
			<?/* ///// !!!!! */?>


			<div id="PRODUCT_SUMMA_ALL">
				<div>
					<?=SaleFormatCurrency($str_PRICE, $str_CURRENCY);?>
				</div>
			</div>
		</td>
		<td>&nbsp;
			<script type="text/javascript">
				var orderWeight = '<?=$productWeight?>';
				var orderPrice = '<?=$str_PRICE?>';


				<?/* ///// !!!!! -  ,      (  ) */?>
				var delivery_price_new = false;
				<?/* ///// !!!!! */?>


				window.onload = function () {
					<?
					if ($bVarsFromForm)
					{
						echo "fRecalProduct('', '');";
					}
					?>
				};
				function pJCFloatDiv()
				{
					var _this = this;
					this.floatDiv = null;
					this.x = this.y = 0;

					this.Show = function(div, left, top)
					{
						var zIndex = parseInt(div.style.zIndex);
						if(zIndex <= 0 || isNaN(zIndex))
							zIndex = 1100;
						div.style.zIndex = zIndex;
						div.style.left = left + "px";
						div.style.top = top + "px";

						if(jsUtils.IsIE())
						{
							var frame = document.getElementById(div.id+"_frame");
							if(!frame)
							{
								frame = document.createElement("IFRAME");
								frame.src = "javascript:''";
								frame.id = div.id+"_frame";
								frame.style.position = 'absolute';
								frame.style.zIndex = zIndex-1;
								document.body.appendChild(frame);
							}
							frame.style.width = div.offsetWidth + "px";
							frame.style.height = div.offsetHeight + "px";
							frame.style.left = div.style.left;
							frame.style.top = div.style.top;
							frame.style.visibility = 'visible';
						}
					}
					this.Close = function(div)
					{
						if(!div)
							return;
						var frame = document.getElementById(div.id+"_frame");
						if(frame)
							frame.style.visibility = 'hidden';
					}
				}
				var pjsFloatDiv = new pJCFloatDiv();

				function SaleBasketEdit()
				{
					var _this = this;
					this.active = null;

					this.PopupShow = function(div, pos)
					{
						this.PopupHide();
						if(!div)
							return;
						if (typeof(pos) != "object")
							pos = {};

						this.active = div.id;
						div.ondrag = jsUtils.False;

						jsUtils.addEvent(document, "keypress", _this.OnKeyPress);

						div.style.width = div.offsetWidth + 'px';
						div.style.visibility = 'visible';

						var res = jsUtils.GetWindowSize();
						pos['top'] = parseInt(res["scrollTop"] + res["innerHeight"]/2 - div.offsetHeight/2);
						pos['left'] = parseInt(res["scrollLeft"] + res["innerWidth"]/2 - div.offsetWidth/2);
						if(pos['top'] < 5)
							pos['top'] = 5;
						if(pos['left'] < 5)
							pos['left'] = 5;

						pjsFloatDiv.Show(div, pos["left"], pos["top"]);
					}

					this.PopupHide = function()
					{
						var div = document.getElementById(_this.active);
						if(div)
						{
							pjsFloatDiv.Close(div);
							div.parentNode.removeChild(div);
						}
						this.active = null;
						jsUtils.removeEvent(document, "keypress", _this.OnKeyPress);
					}

					this.OnKeyPress = function(e)
					{
						if(!e) e = window.event
						if(!e) return;
						if(e.keyCode == 27)
							_this.PopupHide();
					},

					this.IsVisible = function()
					{
						return (document.getElementById(this.active).style.visibility != 'hidden');
					}
				}

				check_ctrl_enter = function(e)
				{
					if(!e)
						e = window.event;

					if((e.keyCode == 13 || e.keyCode == 10) && e.ctrlKey)
					{
						alert('submit!');
					}
				}
				SaleBasketEditTool = new SaleBasketEdit();

				function ShowProductEdit(id, newElement)
				{
					var div = document.createElement("DIV");
					div.id = "product_edit";
					div.style.visible = 'hidden';
					div.style.position = 'absolute';
					div.innerHTML = '<?=$formTemplate?>';

					document.body.appendChild(div);
					SaleBasketEditTool.PopupShow(div);

					if (id != "")
					{
						document.getElementById('FORM_NEWPROD_CODE').style.display = 'none'
						document.getElementById('FORM_BASKET_PRODUCT_ID').value = id;
						document.getElementById('FORM_PROD_BASKET_ID').value = id;
						document.getElementById('FORM_PROD_BASKET_NAME').value = document.getElementById('product_name_' + id).innerHTML;
						document.getElementById('FORM_PROD_BASKET_DETAIL_URL').value = document.getElementById('PRODUCT[' + id + '][DETAIL_PAGE_URL]').value;
						document.getElementById('FORM_PROD_BASKET_NOTES').value = document.getElementById('product_notes_' + id).innerHTML;
						document.getElementById('FORM_BASKET_CATALOG_XML').value = document.getElementById('PRODUCT[' + id + '][CATALOG_XML_ID]').value;
						document.getElementById('FORM_PROD_BASKET_PRODUCT_XML').value = document.getElementById('PRODUCT[' + id + '][PRODUCT_XML_ID]').value;
						document.getElementById('FORM_PROD_BASKET_PRICE').value = document.getElementById('PRODUCT[' + id + '][PRICE]').value;
						document.getElementById('FORM_PROD_BASKET_WEIGHT').value = document.getElementById('PRODUCT[' + id + '][WEIGHT]').value;
						document.getElementById('FORM_PROD_BASKET_QUANTITY').value = document.getElementById('PRODUCT[' + id + '][QUANTITY]').value;
					}
					if (id != "" && arProductEditCountProps[id])
					{
						propCnt = parseInt(arProductEditCountProps[id]);
						for (i=1; i <= propCnt; i++)
						{
							if(document.getElementById("PRODUCT_PROPS_NAME_" + id + "_" + i))
							{
								nameProp = document.getElementById("PRODUCT_PROPS_NAME_" + id + "_" + i).value;
								codeProp = document.getElementById("PRODUCT_PROPS_CODE_" + id + "_" + i).value;
								valueProp = document.getElementById("PRODUCT_PROPS_VALUE_" + id + "_" + i).value;
								sortProp = document.getElementById("PRODUCT_PROPS_SORT_" + id + "_" + i).value;

								BasketAddPropSection(i, nameProp, codeProp, valueProp, sortProp);
							}
						}
					}
					else if (id != "")
						arProductEditCountProps[id] = 0;

				}
				function bxsalehtmlspecialchars(str)
				{
					if(!(typeof(str) == "string" || str instanceof String))
						return str;

					str = str.replace(/&/g, '&amp;');
					str = str.replace(/"/g, '&quot;');
					str = str.replace(/</g, '&lt;');
					str = str.replace(/>/g, '&gt;');
					str = str.replace(/\#/g, '&#35;');
					str = str.replace(/\!/g, '&#33;');
					str = str.replace(/\$/g, '&#36;');
					str = str.replace(/\%/g, '&#37;');
					str = str.replace(/\~/g, '&#126;');
					return str;
				}

				function SaveProduct()
				{
					var error = '';

					prod_id = document.getElementById('FORM_PROD_BASKET_ID').value;
					prod_id = parseInt(prod_id);

					if(prod_id.length <= 0 || isNaN(prod_id))
						error += '<?=GetMessage("SOE_NEW_ERR_PROD_ID")?><br />';
					if(document.getElementById('FORM_PROD_BASKET_NAME').value.length <= 0)
						error += '<?=GetMessage("SOE_NEW_ERR_PROD_NAME")?><br />';

					if(error.length > 0)
					{
						document.getElementById('basketError').style.display = 'block';
						document.getElementById('basketErrorText').innerHTML = error;
					}
					else
					{
						if (!arProductEditCountProps[prod_id])
							arProductEditCountProps[prod_id] = 0;
						propCnt = parseInt(arProductEditCountProps[prod_id]);

						var propsHTML = "";
						var props = "";
						if(propCnt > 0)
						{
							for (i=1; i <= propCnt; i++)
							{
								if (document.getElementById('FORM_PROD_PROP_' + prod_id + '_NAME_' + i))
								{
									propName = document.getElementById('FORM_PROD_PROP_' + prod_id + '_NAME_' + i).value;
									propCode = document.getElementById('FORM_PROD_PROP_' + prod_id + '_CODE_' + i).value;
									propValue = document.getElementById('FORM_PROD_PROP_' + prod_id + '_VALUE_' + i).value;
									propSort = document.getElementById('FORM_PROD_PROP_' + prod_id + '_SORT_' + i).value;

									if (propName != "" && propValue != "")
									{
										//basket visible props
										if(document.getElementById('FORM_PROD_PROP_' + prod_id + '_NAME_' + i).value.length > 0)
											propsHTML += bxsalehtmlspecialchars(propName + ': ' + propValue) + '<br />';

										props += "<input type=\"hidden\" name=\"PRODUCT[" + prod_id + "][PROPS]["+i+"][NAME]\" id=\"PRODUCT_PROPS_NAME_" + prod_id + "_" + i + "\" value=\"" + propName + "\" />";
										props += "<input type=\"hidden\" name=\"PRODUCT[" + prod_id + "][PROPS]["+i+"][CODE]\" id=\"PRODUCT_PROPS_CODE_" + prod_id + "_" + i + "\" value=\"" + propCode + "\" />";
										props += "<input type=\"hidden\" name=\"PRODUCT[" + prod_id + "][PROPS]["+i+"][VALUE]\" id=\"PRODUCT_PROPS_VALUE_" + prod_id + "_" + i + "\" value=\"" + propValue + "\" />";
										props += "<input type=\"hidden\" name=\"PRODUCT[" + prod_id + "][PROPS]["+i+"][SORT]\" id=\"PRODUCT_PROPS_SORT_" + prod_id + "_" + i + "\" value=\"" + propSort + "\" />";
									}
									else
									{
										arProductEditCountProps[prod_id] = propCnt - 1;
									}
								}
							}

							if (document.getElementById('PRODUCT_PROPS_USER_' + prod_id))//&& propsHTML.length > 0
							{
								document.getElementById('PRODUCT_PROPS_USER_' + prod_id).innerHTML = propsHTML;
								document.getElementById('product_props_' + prod_id).innerHTML = props;
							}
						}

						if (document.getElementById('FORM_BASKET_PRODUCT_ID').value != "")
						{
							document.getElementById('PRODUCT[' + prod_id + '][DETAIL_PAGE_URL]').value = document.getElementById('FORM_PROD_BASKET_DETAIL_URL').value;
							document.getElementById('product_name_' + prod_id).innerHTML = document.getElementById('FORM_PROD_BASKET_NAME').value;
							document.getElementById('PRODUCT[' + prod_id + '][NAME]').value = document.getElementById('FORM_PROD_BASKET_NAME').value;
							document.getElementById('product_notes_' + prod_id).innerHTML = document.getElementById('FORM_PROD_BASKET_NOTES').value;
							document.getElementById('PRODUCT[' + prod_id + '][NOTES]').value = document.getElementById('FORM_PROD_BASKET_NOTES').value;
							document.getElementById('PRODUCT[' + prod_id + '][CATALOG_XML_ID]').value = document.getElementById('FORM_BASKET_CATALOG_XML').value;
							document.getElementById('PRODUCT[' + prod_id + '][PRODUCT_XML_ID]').value = document.getElementById('FORM_PROD_BASKET_PRODUCT_XML').value;
							document.getElementById('PRODUCT[' + prod_id + '][QUANTITY]').value = document.getElementById('FORM_PROD_BASKET_QUANTITY').value;

							if (document.getElementById('PRODUCT[' + prod_id + '][PRICE]').value != document.getElementById('FORM_PROD_BASKET_PRICE').value)
							{
								document.getElementById('PRODUCT[' + prod_id + '][PRICE]').value = document.getElementById('FORM_PROD_BASKET_PRICE').value;
								document.getElementById('CALLBACK_FUNC_' + prod_id).value = "Y";
							}

							if (document.getElementById('PRODUCT[' + prod_id + '][WEIGHT]').value != document.getElementById('FORM_PROD_BASKET_WEIGHT').value)
							{
								document.getElementById('PRODUCT[' + prod_id + '][WEIGHT]').value = document.getElementById('FORM_PROD_BASKET_WEIGHT').value;
								document.getElementById('CALLBACK_FUNC_' + prod_id).value = "Y";
							}
						}
						else
						{
							var arParamsTmp = [];
							arParamsTmp['id'] = prod_id;
							arParamsTmp['name'] = bxsalehtmlspecialchars(document.getElementById('FORM_PROD_BASKET_NAME').value);
							arParamsTmp['price'] = document.getElementById('FORM_PROD_BASKET_PRICE').value;
							arParamsTmp['summaFormated'] = 1;
							arParamsTmp['priceType'] = document.getElementById('FORM_PROD_BASKET_NOTES').value;
							arParamsTmp['priceDiscount'] = 0;
							arParamsTmp['priceDiscountFormated'] = 0;
							arParamsTmp['quantity'] = document.getElementById('FORM_PROD_BASKET_QUANTITY').value;
							arParamsTmp['url'] = document.getElementById('FORM_PROD_BASKET_DETAIL_URL').value;
							arParamsTmp['urlImg'] = '';
							arParamsTmp['vatRate'] = 0;
							arParamsTmp['weight'] = document.getElementById('FORM_PROD_BASKET_WEIGHT').value;
							arParamsTmp['currency'] = '<?=$str_CURRENCY?>';
							arParamsTmp['priceValutaFormat'] = '';
							arParamsTmp['module'] = '';
							arParamsTmp['callback'] = '';
							arParamsTmp['orderCallback'] = '';
							arParamsTmp['cancelCallback'] = '';
							arParamsTmp['payCallback'] = '';
							arParamsTmp['catalogXmlID'] = document.getElementById('FORM_BASKET_CATALOG_XML').value;
							arParamsTmp['productXmlID'] = document.getElementById('FORM_PROD_BASKET_PRODUCT_XML').value;

							FillProductFields('', arParamsTmp, '');

							if (propsHTML.length > 0)
							{
								document.getElementById('PRODUCT_PROPS_USER_' + prod_id).innerHTML = propsHTML;
								document.getElementById('product_props_' + prod_id).innerHTML = props;
							}
						}
						fRecalProduct('', '');
						SaleBasketEditTool.PopupHide();
					}
				}

				function BasketAddPropSection(id, nameProp, codeProp, valueProp, sortProp)
				{
					var error = '';

					if (!nameProp)
						nameProp = "";
					if (!codeProp)
						codeProp = "";
					if (!valueProp)
						valueProp = "";
					if (!sortProp)
						sortProp = "";
					if (!id)
						id = "";

					prod_id = document.getElementById('FORM_PROD_BASKET_ID').value;
					prod_id = parseInt(prod_id);

					if(prod_id.length <= 0 || isNaN(prod_id))
						error += '<?=GetMessage("SOE_NEW_ERR_PROD_ID")?><br />';

					if(error.length > 0)
					{
						document.getElementById('basketError').style.display = 'block';
						document.getElementById('basketErrorText').innerHTML = error;
					}
					else
					{
						if (id == '')
						{
							if (!arProductEditCountProps[prod_id])
								arProductEditCountProps[prod_id] = 0;

							countProp = parseInt(arProductEditCountProps[prod_id]);
							countProp = countProp + 1;
							arProductEditCountProps[prod_id] = countProp;
						}
						else
						{
							countProp = id;
						}

						var oTbl = document.getElementById("BASKET_PROP_TABLE");
						if (!oTbl)
							return;
						var oRow = oTbl.insertRow(-1);
						var oCell = oRow.insertCell(-1);
						oCell.innerHTML = '<input type="text" maxlength="250" size="20" name="FORM_PROD_PROP_' + prod_id + '_NAME_' + countProp + '" id="FORM_PROD_PROP_' + prod_id + '_NAME_' + countProp + '" value="'+nameProp+'" />';
						var oCell = oRow.insertCell(-1);
						oCell.innerHTML = '<input type="text" maxlength="250" size="20" name="FORM_PROD_PROP_' + prod_id + '_VALUE_' + countProp + '" id="FORM_PROD_PROP_' + prod_id + '_VALUE_' + countProp + '" value="'+valueProp+'" />';
						var oCell = oRow.insertCell(-1);
						oCell.innerHTML = '<input type="text" maxlength="250" size="3" name="FORM_PROD_PROP_' + prod_id + '_CODE_' + countProp + '" id="FORM_PROD_PROP_' + prod_id + '_CODE_' + countProp + '" value="'+codeProp+'" />';
						var oCell = oRow.insertCell(-1);
						oCell.innerHTML = '<input type="text" maxlength="10" size="2" name="FORM_PROD_PROP_' + prod_id + '_SORT_' + countProp + '" id="FORM_PROD_PROP_' + prod_id + '_SORT_' + countProp + '" value="'+sortProp+'" />';
					}
				}
			</script>
		</td>
	</tr>
</table>
</td>
</tr>
<tr>
	<td valign="top" align="center" colspan="2">
		<input type="button" value="<?=GetMessage("SOE_ADD_ITEMS")?>" OnClick="AddProductSearch(1);">
		<input type="button" value="<?=GetMessage("SOE_NEW_ITEMS")?>" OnClick="ShowProductEdit('', 'Y');">

<script language="JavaScript">
	var currencyBase = '<?=CSaleLang::GetLangCurrency($LID);?>';

	function AddProductSearch(index)
	{
		var quantity = 1;
		var BUYER_ID = document.form_order_form.user_id.value;
		var BUYER_CUPONS = document.getElementById("CUPON").value;

		window.open('/bitrix/admin/sale_product_search.php?lang=<?=LANGUAGE_ID?>&LID=<?=$LID?>&func_name=FillProductFields&index=' + index + '&QUANTITY=' + quantity + '&BUYER_ID=' + BUYER_ID + '&BUYER_COUPONS=' + BUYER_CUPONS, '', 'scrollbars=yes,resizable=yes,width=600,height=500,top='+parseInt((screen.height - 500)/2-14)+',left='+parseInt((screen.width - 600)/2-5));
	}

	function FillProductFields(index, arParams, iblockID)
	{
		var ID = arParams['id'];

		if (!document.getElementById('BASKET_TABLE_ROW_' + ID))
		{
			var oTbl = document.getElementById("BASKET_TABLE");
			if (!oTbl)
				return;

			var oRow = oTbl.insertRow(oTbl.rows.length - 1);
			oRow.setAttribute('id','BASKET_TABLE_ROW_' + ID);
			oRow.setAttribute('style','font-style:italic');

			var oCellName = oRow.insertCell(-1);
			var oCellTypePrice = oRow.insertCell(-1);
				oCellTypePrice.setAttribute('id','DIV_TYPEPRICE_' + ID);
			var oCellPROPS = oRow.insertCell(-1);
			var oCellQuantity = oRow.insertCell(-1);
				oCellQuantity.setAttribute('align','center');
				oCellQuantity.setAttribute('id','DIV_QUANTITY_' + ID);
			var oCellPrice = oRow.insertCell(-1);
				oCellPrice.setAttribute('align','center');
				oCellPrice.setAttribute('id','DIV_PRICE_' + ID);
			var oCellDiscount = oRow.insertCell(-1);
				oCellDiscount.setAttribute('align','right');
				oCellDiscount.setAttribute('id','DIV_DISCOUNT_' + ID);
			var oCellSumma = oRow.insertCell(-1);
				oCellSumma.setAttribute('align','right');
				oCellSumma.setAttribute('id','DIV_SUMMA_' + ID);
			var oCellDelete = oRow.insertCell(-1);
				oCellDelete.setAttribute('align','center');

			for (key in arParams)
			{
				if (key == "id")
				{
					ID = arParams[key];
				}
				if (key == "name")
				{
					var name = arParams[key];
				}
				else if (key == "price")
				{
					var price = arParams[key];
				}
				else if (key == "priceType")
				{
					var priceType = arParams[key];
				}
				else if (key == "priceValutaFormat")
				{
					var priceValutaFormat = arParams[key];
				}
				else if (key == "currency")
				{
					var currency = arParams[key];
				}
				else if (key == "priceDiscount")
				{
					var priceDiscount = arParams[key];
				}
				else if (key == "priceDiscountFormated")
				{
					var priceDiscountFormated = arParams[key];
				}
				else if (key == "quantity")
				{
					var quantity = arParams[key];
				}
				else if (key == "summaFormated")
				{
					var summaFormated = arParams[key];
				}
				else if (key == "weight")
				{
					var weight = arParams[key];
				}
				else if (key == "vatRate")
				{
					var vatRate = arParams[key];
				}
				else if (key == "module")
				{
					var module = arParams[key];
				}
				else if (key == "catalogXmlID")
				{
					var catalogXmlID = arParams[key];
				}
				else if (key == "productXmlID")
				{
					var productXmlID = arParams[key];
				}
				else if (key == "url")
				{
					var url = arParams[key];
				}
				else if (key == "urlImg")
				{
					var urlImg = arParams[key];
				}
				else if (key == "callback")
				{
					var callback = arParams[key];
				}
				else if (key == "orderCallback")
				{
					var orderCallback = arParams[key];
				}
				else if (key == "cancelCallback")
				{
					var cancelCallback = arParams[key];
				}
				else if (key == "payCallback")
				{
					var payCallback = arParams[key];
				}
			}

			var hiddenField = "<table><tr>";
			if (urlImg != "")
				hiddenField = hiddenField + "<td valign=\"top\" align=\"left\"><img src=\""+urlImg+"\" alt=\"\" width=\"50\" style=\"float:left;margin:3px;\" /></td>";
			hiddenField = hiddenField + "<td align=\"left\" valign=\"middle\"><div id=\"product_name_" + ID + "\">" + name + "</div></td></tr></table>";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"PRODUCT[" + ID + "][CALLBACK_FUNC]\" id=\"CALLBACK_FUNC_" + ID + "\" value=\"" + callback + "\" />\n";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"PRODUCT[" + ID + "][ORDER_CALLBACK_FUNC]\" id=\"ORDER_CALLBACK_FUNC_" + ID + "\" value=\"" + orderCallback + "\" />\n";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"PRODUCT[" + ID + "][CANCEL_CALLBACK_FUNC]\" id=\"CANCEL_CALLBACK_FUNC_" + ID + "\" value=\"" + cancelCallback + "\" />\n";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"PRODUCT[" + ID + "][PAY_CALLBACK_FUNC]\" id=\"PAY_CALLBACK_FUNC_" + ID + "\" value=\"" + payCallback + "\" />\n";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"PRODUCT[" + ID + "][CURRENCY]\" id=\"CURRENCY_" + ID + "\" value=\"" + currency + "\" />";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"PRODUCT[" + ID + "][DISCOUNT_PRICE]\" id=\"PRODUCT[" + ID + "][DISCOUNT_PRICE]\" value=\"" + priceDiscount + "\" />";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"PRODUCT[" + ID + "][WEIGHT]\" id=\"PRODUCT[" + ID + "][WEIGHT]\" value=\"" + weight + "\" />";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"PRODUCT[" + ID + "][VAT_RATE]\" id=\"PRODUCT[" + ID + "][VAT_RATE]\" value=\"" + vatRate + "\" />";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"PRODUCT[" + ID + "][MODULE]\" id=\"PRODUCT[" + ID + "][MODULE]\" value=\"" + module + "\" />";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"BUSKET_" +  ID + "\" id=\"BUSKET_" + ID + "\" value=\"\" />";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"PRODUCT[" + ID + "][NOTES]\" id=\"PRODUCT[" + ID + "][NOTES]\" value=\"" + priceType + "\" />";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"PRODUCT[" + ID + "][CATALOG_XML_ID]\" id=\"PRODUCT[" + ID + "][CATALOG_XML_ID]\" value=\"" + catalogXmlID + "\" />";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"PRODUCT[" + ID + "][PRODUCT_XML_ID]\" id=\"PRODUCT[" + ID + "][PRODUCT_XML_ID]\" value=\"" + productXmlID + "\" />";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"PRODUCT[" + ID + "][DETAIL_PAGE_URL]\" id=\"PRODUCT[" + ID + "][DETAIL_PAGE_URL]\" value=\"" + url + "\" />";
			hiddenField = hiddenField + "<input type=\"hidden\" name=\"PRODUCT[" + ID + "][NAME]\" id=\"PRODUCT[" + ID + "][NAME]\" value=\"" + name + "\" />";
			hiddenField = hiddenField + "<span id=\"product_props_" + ID + "\"></span>";

			oCellName.innerHTML = hiddenField;
			oCellPROPS.innerHTML = "<div id=\"PRODUCT_PROPS_USER_" + ID + "\"></div>";
			oCellTypePrice.innerHTML = "<div id=\"product_notes_" + ID + "\">" + priceType + "</div>";
			oCellQuantity.innerHTML = "<div><input onChange=\"fRecalProduct(" + ID + ", '');\" type=\"text\" name=\"PRODUCT[" + ID + "][QUANTITY]\" id=\"PRODUCT[" + ID + "][QUANTITY]\" value=\"" + quantity + "\" size=\"4\"></div>";
			oCellPrice.innerHTML = "<div><input onChange=\"fRecalProduct(" + ID + ", 'price');\" type=\"text\" name=\"PRODUCT[" + ID + "][PRICE]\" id=\"PRODUCT[" + ID + "][PRICE]\" value=\"" + price + "\" size=\"10\"></div>";
			oCellDiscount.innerHTML = "<div>" + priceDiscountFormated + "</div>";
			oCellSumma.innerHTML = "<div>" + summaFormated  + "</div>";
			oCellDelete.innerHTML = "<div><a href=\"javascript:void(0)\" onClick=\"ShowProductEdit(" + ID + ", 'Y');\"><?=GetMessage("SOE_JS_EDIT")?></a><br /><a href=\"javascript:void(0)\" onClick=\"DeleteProduct(this, " + ID + ");\"><?=GetMessage('SOE_JS_DEL')?></a></div>";

			//array product in busket
			arProduct[ID] = ID;
		}
		else
		{
			var quantity = parseFloat(document.getElementById("PRODUCT[" + ID + "][QUANTITY]").value) + 1;
			document.getElementById("PRODUCT[" + ID + "][QUANTITY]").value = quantity;
		}
		fRecalProduct(document.getElementById("PRODUCT[" + ID + "][QUANTITY]"), ID);
	}

	function DeleteProduct(el, id)
	{
		if (confirm('<?=GetMessage('SALE_CONFIRM_DELETE')?>'))
		{
			var trDel = document.getElementById("BASKET_TABLE_ROW_" + id).sectionRowIndex;
			var oTbl = document.getElementById("BASKET_TABLE");
			oTbl.deleteRow(trDel);
			delete arProduct[id];

			fRecalProduct('', '');
		}

		return false;
	}

	function fRecalProduct(id, type)
	{
		var location = '';
		var locationZip = '';
		var paySystemId = '';
		var deliveryId = '';
		var buyerTypeId = '';
		var cupon = '';
		var user_id = document.form_order_form.user_id.value;
		var productData = "{";
		var j = 0;

		if (type != "" && type == "price")
			document.getElementById('CALLBACK_FUNC_' + id).value = "Y";

		for(var i in arProduct)
		{
			if (j > 0)
				productData = productData + ",";

			discount = '';
			if (document.getElementById('PRODUCT[' + i + '][DISCOUNT_PRICE]'))
				discount = document.getElementById('PRODUCT[' + i + '][DISCOUNT_PRICE]').value;

			var taxOrder = '<?=$str_TAX_VALUE?>';

			productData = productData + "'" + i + "':{'BUSKET_ID':'" + document.getElementById('BUSKET_' + i).value + "', \n\
						'CALLBACK_FUNC':'" + document.getElementById('CALLBACK_FUNC_' + i).value + "',\n\
						'ORDER_CALLBACK_FUNC':'" + document.getElementById('ORDER_CALLBACK_FUNC_' + i).value + "',						\n\
						'CANCEL_CALLBACK_FUNC':'" + document.getElementById('CANCEL_CALLBACK_FUNC_' + i).value + "',\n\
						'PAY_CALLBACK_FUNC':'" + document.getElementById('PAY_CALLBACK_FUNC_' + i).value + "',\n\
						'QUANTITY':'" + document.getElementById('PRODUCT[' + i + '][QUANTITY]').value + "',\n\
						'CURRENCY':'" + document.getElementById('CURRENCY_' + i).value + "',\n\
						'PRICE':'" + document.getElementById('PRODUCT[' + i + '][PRICE]').value + "',\n\
						'WEIGHT':'" + document.getElementById('PRODUCT[' + i + '][WEIGHT]').value + "',\n\
						'MODULE':'" + document.getElementById('PRODUCT[' + i + '][MODULE]').value + "',\n\
						'VAT_RATE':'" + document.getElementById('PRODUCT[' + i + '][VAT_RATE]').value + "',\n\
						'TAX_VALUE':'" + taxOrder + "',\n\
						'DISCOUNT_PRICE':'" + discount + "'}";
			j++;
		}
		productData = productData + "}";

		if (document.getElementById('CITY_ORDER_PROP_' + locationID))
			location = document.getElementById('CITY_ORDER_PROP_' + locationID).value;
		if (document.getElementById('ORDER_PROP_' + locationZipID))
			locationZip = document.getElementById('ORDER_PROP_' + locationZipID).value;

		var deliveryPrice = 0;


		<?/* ///// !!!!! -  :     ,     */?>
<? /*
		if (document.getElementById('DELIVERY_ID_auto').value != '')
		{
			deliveryId = document.getElementById('DELIVERY_ID_auto').value;
			deliveryPrice = parseFloat(document.getElementById('DELIVERY_ID_auto_text').value);
		}
		if (deliveryId == '')
		{
			deliveryId = document.getElementById('DELIVERY_ID_conf').value;
			deliveryPrice = parseFloat(document.getElementById('DELIVERY_ID_conf_text').value);
		}
*/ ?>
		if (document.forms.form_order_form.DELIVERY_type.value == 'handler') {
			deliveryId = document.getElementById('DELIVERY_ID_auto').value;
			deliveryPrice = parseFloat(document.getElementById('DELIVERY_ID_auto_text').value);
		}
		else {
			deliveryId = document.getElementById('DELIVERY_ID_conf').value;
			deliveryPrice = parseFloat(document.getElementById('DELIVERY_ID_conf_text').value);
		}

		if (delivery_price_new) delivery_price_new = false; else deliveryPrice = -1;
		<?/* ///// !!!!! */?>


		paySystemId = document.getElementById('PAY_SYSTEM_ID').value;
		buyerTypeId = document.getElementById('buyer_type_id').value;
		cupon = document.getElementById('CUPON').value;

		dateURL = '<?=CUtil::JSEscape(bitrix_sessid_get())?>&ORDER_AJAX=Y&LID=<?=$LID?>&user_id=' + user_id + '&cupon=' + cupon + '&currency=' + currencyBase + '&deliveryId=' + deliveryId + '&paySystemId=' + paySystemId + '&deliveryPrice=' + deliveryPrice + '&buyerTypeId=' + buyerTypeId + '&locationID=' + locationID + '&location=' + location + '&locationZipID=' + locationZipID + '&locationZip=' + locationZip + '&product=' + productData;

		BX.showWait();
		BX.ajax.post('/bitrix/admin/sale_order_new.php', dateURL, fRecalProductResult);
	}
	function fRecalProductResult(result)
	{
		BX.closeWait();
		if (result.length > 0)
		{
			var res = eval( '('+result+')' );

			for(var i in res) {
				if (i > 0)
				{
					document.getElementById('PRODUCT[' + i + '][PRICE]').value = res[i]["PRICE"];
					document.getElementById('DIV_DISCOUNT_' + i).innerHTML = res[i]["DISCOUNT_PRICE_DISPLAY"];
					document.getElementById('DIV_SUMMA_' + i).innerHTML = "<div>" + res[i]["SUMMA_DISPLAY"] + "</div>";
					document.getElementById('PRODUCT[' + i + '][QUANTITY]').value = res[i]["QUANTITY"];
				}
			}
			document.getElementById('PRODUCT_COUNT_ALL').innerHTML = "<div>" + res[0]["COUNT_TOTAL"] + "</div>";
			document.getElementById('PRODUCT_SUMMA_ALL').innerHTML = "<div>" + res[0]["PRICE_TOTAL_DISPLAY"] + "</div>";
			document.getElementById('PRODUCT_VAT_ALL').innerHTML = "<div>" + res[0]["VAT_DISPLAY"] + "</div>";
			document.getElementById('PRODUCT_WAIGHT_ALL').innerHTML = "<div>" + res[0]["WEIGHT_DISPLAY"] + "</div>";
			document.getElementById('PAY_CURRENT_ACCOUNT_DESC').innerHTML = res[0]["PAY_ACCOUNT"];
			document.getElementById('DELIVERY_ID_handler').innerHTML = res[0]["DELIVERY_AUTO"];
			document.getElementById('DELIVERY_ID').innerHTML = res[0]["DELIVERY_CONFIG"];
			document.getElementById('ITOG_ORDER_SUM').innerHTML = res[0]["PRICE_TOTAL_DISPLAY"];
			document.getElementById('DISCOUNT_SHOP_ALL').innerHTML = "<div>" + res[0]["DISCOUNT_VALUE_DISPLAY"] + "</div>";

			if (res[0]["DELIVERY_CONFIG_DEFAULT"] == "")
				document.getElementById('DELIVERY_ID_conf_text').value = res[0]["DELIVERY_CONFIG_DEFAULT"];
			if (res[0]["DELIVERY_AUTO_DEFAULT"] == "")
				document.getElementById('DELIVERY_ID_auto_text').value = res[0]["DELIVERY_AUTO_DEFAULT"];

			orderWeight = res[0]["WEIGHT_TOTAL"];
			orderPrice = res[0]["PRICE_TOTAL"];


			<?/* ///// !!!!! -    */?>
			orderPrice = res[0]["ORDER_PRICE"];
			document.getElementById('DELIVERY_ALL').innerHTML = "<div>" + res[0]["DELIVERY_TOTAL_DISPLAY"] + "</div>";

			if (res[0]["DELIVERY_CONFIG_DEFAULT"] != '')
				document.getElementById('DELIVERY_ID_conf_text').value = res[0]["DELIVERY_TOTAL"];
			if (res[0]["DELIVERY_AUTO_DEFAULT"] != '')
				document.getElementById('DELIVERY_ID_auto_text').value = res[0]["DELIVERY_TOTAL"];

			document.getElementById('errorDeliverCalc').innerHTML = '<font color="#FF0000"><b>' + res[0]["delivery_error"] + '</b></font>';
			<?/* ///// !!!!! */?>


		}
	}

	function fRecalcDelivery()
	{
		fRecalProduct('', '');
	}
</script>
	</td>
</tr>

<?
$tabControl->EndCustomField("BASKET_CONTAINER");


//TAB ORDER PARAMETERS
$tabControl->BeginNextFormTab();

$arPersonTypeList = array();
$dbPersonType = CSalePersonType::GetList(array("SORT" => "ASC", "NAME" => "ASC"), array("ACTIVE" => "Y"));
while ($arPersonType = $dbPersonType->GetNext())
{
	$arPersonTypeList[$arPersonType["ID"]] = $arPersonType;
}
$tabControl->BeginCustomField("BUYER_TYPE", GetMessage("SOE_PERSON_TYPE"), true);
?>
<tr>
	<td width="40%">
		<span class="required">*</span><?=GetMessage("SOE_PERSON_TYPE") ?>:
	</td>
	<td width="60%">
		<select name="buyer_type_id" id="buyer_type_id" OnChange="fBuyerChangeType(this);">
		<?
			foreach($arPersonTypeList as $arPersTypeList)
			{
				if (!in_array($LID, $arPersTypeList["LIDS"]))
					continue;

				if (!isset($str_PERSON_TYPE_ID) OR $str_PERSON_TYPE_ID == "")
					$str_PERSON_TYPE_ID = $arPersTypeList["ID"];
			?>
				<option value="<?echo $arPersTypeList["ID"] ?>" <?if (IntVal($arPersTypeList["ID"])==IntVal($str_PERSON_TYPE_ID)) echo " selected"?> >[<?echo $arPersTypeList["ID"] ?>] <?echo $arPersTypeList["NAME"] ?></option>
			<? } ?>
		</select>

		<script language="JavaScript">
			var orderID = '<?=$ID?>';
			var orderPaySysyemID = '<?=$str_PAY_SYSTEM_ID?>';

			function fBuyerChangeType(el)
			{
				var userId = "";

				if (document.getElementById("user_id").value != "")
				{
					userId = document.getElementById("user_id").value;
				}
				BX.showWait();
				BX.ajax.post('/bitrix/admin/sale_order_new.php', '<?=CUtil::JSEscape(bitrix_sessid_get())?>&ORDER_AJAX=Y&paysystemid=' + orderPaySysyemID + '&ID=' + orderID + '&LID=<?=$LID?>&buyertypechange=' + el.value + '&userId=' + userId, fBuyerChangeTypeResult);
			}
			function fBuyerChangeTypeResult(res)
			{
				BX.closeWait();
				var rss = eval( '('+res+')' );

				if (rss["status"] == "ok")
				{
					var userEl = document.getElementById("user_id");
					var orderID = '<?=$ID?>';

					locationID = rss["location_id"];
					locationZipID = rss["location_zip_id"];

					document.getElementById("buyer_type_change").innerHTML = rss["buyertype"];
					document.getElementById("buyer_type_delivery").innerHTML = rss["buyerdelivery"];
					if (userEl.value != "" && (orderID == '' || orderID == 0))
					{
						fUserGetProfile(userEl);
					}
					else
					{
						fRecalcDelivery();
					}
				}
			}

			function fChangeProfile(el)
			{
				BX.showWait();

				var userId = document.getElementById("user_id").value;
				var buyerType = document.getElementById("buyer_type_id").value;

				if (userId != "" && buyerType != "")
				{
					fGetExecScript(userId, buyerType, el.value);
				}
				else
				{
					BX.closeWait();
				}
			}

			function fLocationResult(result)
			{
				var res = eval( '('+result+')' );

				if (res["status"] == "ok")
				{
					document.getElementById("ORDER_PROP_" + res["propid"]).value = res["countryid"];
					document.getElementById("city_list").innerHTML = res["citylist"];
					fRecalProduct('', '');
				}
			}
		</script>
	</td>
</tr>

<?
$tabControl->EndCustomField("BUYER_TYPE");

$tabControl->BeginCustomField("BUYER_PROFILE", GetMessage("NEWO_BUYER_PROFILE"), true);
$profileUser = "";
$profileLook = "";
if (isset($user_profile))
{
	$profileUser = fUserProfile($str_USER_ID, $str_PERSON_TYPE_ID, $user_profile);
	$profileLook = "Y";
}
?>
<tr id="buyer_profile_display" style="<?=(($profileLook == "") ? 'display:none' : '' ) ?>" >
	<td width="40%">
		<span class="required">*</span><?=GetMessage("NEWO_BUYER_PROFILE")?>:
	</td>
	<td width="60%">
		<div id="buyer_profile_select"><?=$profileUser?></div>
	</td>
</tr>
<?
$tabControl->EndCustomField("BUYER_PROFILE");

$tabControl->BeginCustomField("BUYER_TYPE_PARAMS", GetMessage("NEWO_BUYER_ORDER_PROPS"), true);
?>
<tr>
	<td id="buyer_type_change" colspan="2">
		<?=fBuyerType($str_PERSON_TYPE_ID, $str_USER_ID, $ID, $LID, $lang, $bVarsFromForm);?>
	</td>
</tr>
<?
$tabControl->EndCustomField("BUYER_TYPE_PARAMS");


//TAB PAY and ORDER
$tabControl->BeginNextFormTab();
$tabControl->AddSection("BUYER_PAYMENT", GetMessage("SOE_PAYMENT"));

$tabControl->BeginCustomField("PAY_CURRENT_ACCOUNT", GetMessage("NEWO_CURRENT_ACCOUNT"), true);
$accountPayDefault = fGetPayFromAccount($str_USER_ID, $str_CURRENCY);
?>
<tr>
	<td align="left" valign="top" class="field-name" width="40%"><?=GetMessage("NEWO_CURRENT_ACCOUNT")?></td>
	<td align="left">
		<input type="checkbox" name="PAY_CURRENT_ACCOUNT" id="PAY_CURRENT_ACCOUNT" value="Y"  <?if ($PAY_CURRENT_ACCOUNT == "Y") echo " checked";?> /><br />
		<div id="PAY_CURRENT_ACCOUNT_DESC"><?=$accountPayDefault?></div>
	</td>

</tr>
<?
$tabControl->EndCustomField("PAY_CURRENT_ACCOUNT");

$tabControl->BeginCustomField("BUYER_PAY_SYSTEM", GetMessage("SOE_PAY_SYSTEM"), true);
?>
<tr>
	<td id="buyer_type_delivery" colspan="2" class="field-name">
		<?=fBuyerDelivery($str_PERSON_TYPE_ID, $str_PAY_SYSTEM_ID);?>
	</td>
</tr>
<?
$tabControl->EndCustomField("BUYER_PAY_SYSTEM");

$tabControl->BeginCustomField("BUYER_ORDER_PAYED", GetMessage("SOE_ORDER_PAID"), true);
?>
<tr>
	<td width="40%">
		<?=GetMessage("SOE_ORDER_PAID")?>
	</td>
	<td width="60%">
		<input type="checkbox" name="PAYED" OnClick="PayedClicked()" value="Y" <?if ($str_PAYED == "Y") echo " checked";?>>
	</td>
</tr>
<?
$tabControl->EndCustomField("BUYER_ORDER_PAYED");

$tabControl->AddEditField("PAY_VOUCHER_NUM", GetMessage("SOE_VOUCHER_NUM").":", false, array("size"=>30, "maxlength"=>255), $str_PAY_VOUCHER_NUM);

$tabControl->BeginCustomField("BUYER_ORDER_PAYED_DATE", GetMessage("SOE_VOUCHER_DATE"), true);
?>
<tr>
	<td width="40%">
		<?=GetMessage("SOE_VOUCHER_DATE")?> (<?=CSite::GetDateFormat("SHORT", LANG);?>):
	</td>
	<td width="60%">
		<?=CalendarDate("PAY_VOUCHER_DATE", $str_PAY_VOUCHER_DATE, "change_pay_form", "30", "class=\"typeinput\""); ?>

		<script language="JavaScript">
			function PayedClicked()
			{
				document.form_order_form.PAY_VOUCHER_NUM.disabled = !document.form_order_form.PAYED.checked;
				document.form_order_form.PAY_VOUCHER_DATE.disabled = !document.form_order_form.PAYED.checked;
			}
			PayedClicked();
		</script>
	</td>
</tr>
<?
$tabControl->EndCustomField("BUYER_ORDER_PAYED_DATE");

$tabControl->AddSection("BUYER_DELIVERY", GetMessage("SOE_DELIVERY"));

$tabControl->BeginCustomField("BUYER_DELIVERY_ALLOW", GetMessage("SOE_DELIVERY_ALLOWED"), true);
?>
<tr>
	<td width="40%">
		<?=GetMessage("SOE_DELIVERY_ALLOWED")?>
	</td>
	<td width="60%">
		<input type="checkbox" name="ALLOW_DELIVERY" value="Y" OnClick="DeliveryClicked()" <?if ($str_ALLOW_DELIVERY == "Y") echo " checked";?>>
	</td>
</tr>
<?
$tabControl->EndCustomField("BUYER_DELIVERY_ALLOW");

$tabControl->AddEditField("DELIVERY_DOC_NUM", GetMessage("SOE_DEL_VOUCHER_NUM").":", false, array("size"=>30, "maxlength"=>255), $str_DELIVERY_DOC_NUM);

$tabControl->BeginCustomField("DELIVERY_DOC_DATE", GetMessage("SOE_DEL_VOUCHER_DATE"), true);
?>
<tr>
	<td width="40%">
		<?=GetMessage("SOE_DEL_VOUCHER_DATE")?> (<?=CSite::GetDateFormat("SHORT", LANG);?>):
	</td>
	<td width="60%">
		<?=CalendarDate("DELIVERY_DOC_DATE", $str_DELIVERY_DOC_DATE, "change_pay_form", "30", "class=\"typeinput\""); ?>

		<script language="JavaScript">
			function DeliveryClicked()
			{
				document.form_order_form.DELIVERY_DOC_NUM.disabled = !document.form_order_form.ALLOW_DELIVERY.checked;
				document.form_order_form.DELIVERY_DOC_DATE.disabled = !document.form_order_form.ALLOW_DELIVERY.checked;
			}
			DeliveryClicked();
		</script>
	</td>
</tr>
<?
$tabControl->EndCustomField("DELIVERY_DOC_DATE");

$tabControl->BeginCustomField("DELIVWRY_SERVICE", GetMessage("NEWO_DELIVERY_SERVICE"), true);


///// !!!!! -   eDost
//$arDeliveryOrder = fGetDelivery($locationID, $locationZipID, $productWeight, ($str_PRICE-$str_PRICE_DELIVERY), $str_CURRENCY, $LID, $str_DELIVERY_ID);
$arDeliveryOrder = fGetDelivery($locationID, $locationZipID, $productWeight, ($str_PRICE-$str_PRICE_DELIVERY+$str_DISCOUNT_VALUE), $str_CURRENCY, $LID, $str_DELIVERY_ID, $str_PAY_SYSTEM_ID, $str_PERSON_TYPE_ID, $arBasketItem);
///// !!!!!


$bUseDelivery = true;
$bUseDeliveryHandlers = true;
ob_start();
?>
			<tr>
				<td width="40%" align="right" class="field-name">
					<?=GetMessage("SOE_DELIVERY_COM")?>:
				</td>
				<td width="60%">
					<script language="JavaScript">
					var arDeliveryPrice = new Array();
					var arDeliveryCurrency = new Array();
					<?
					$dbDelivery = CSaleDelivery::GetList(
							array("SORT" => "ASC", "NAME" => "ASC"),
							array("LID" => $LID, 'ACTIVE' => 'Y'),
							false,
							false,
							array("ID", "NAME", "SORT", "PRICE", "CURRENCY")
					);
					while ($arDelivery = $dbDelivery->GetNext())
					{
						?>arDeliveryPrice[<?= $arDelivery["ID"] ?>]=<?= $arDelivery["PRICE"] ?>;<?
						?>arDeliveryCurrency[<?= $arDelivery["ID"] ?>]='<?= $arDelivery["CURRENCY"] ?>';<?
					}
					?>

					function DeliveryChange(idTmp)
					{
						arDeliveryPrice[idTmp] = parseInt(arDeliveryPrice[idTmp]);
						if (arDeliveryPrice[idTmp])
							document.form_order_form.PRICE_DELIVERY.value = arDeliveryPrice[idTmp];
						else
							document.form_order_form.PRICE_DELIVERY.value = '0';

						fRecalProduct('', '');
					}
					</script>

					<div id="DELIVERY_ID">
					<?
						$bUseDelivery = true;
						echo $arDeliveryOrder["DELIVERY_CONFIG"];
					?>
					</div>
				</td>
			</tr>
			<tr>
				<td width="40%" align="right" class="field-name">
					<?=GetMessage("SOE_DELIVERY_PRICE")?>:
				</td>
				<td width="60%">
					<?
						if (!strpos($str_DELIVERY_ID, ':'))
							$defaultPrice = roundEx($str_PRICE_DELIVERY, SALE_VALUE_PRECISION);
						else
							$defaultPrice = '';

						if ($bVarsFromForm)
							$defaultPrice = roundEx($PRICE_DELIVERY, SALE_VALUE_PRECISION);
					?>


					<?/* ///// !!!!! -   delivery_price_new */?>
					<?/*
					<input type="text" onChange="fRecalProduct('', '');" name="PRICE_DELIVERY" id="DELIVERY_ID_conf_text" size="10" maxlength="20" value="<?=$defaultPrice;?>" >
					*/?>
					<input type="text" onChange="delivery_price_new = true; fRecalProduct('', '');" name="PRICE_DELIVERY" id="DELIVERY_ID_conf_text" size="10" maxlength="20" value="<?=$defaultPrice;?>" >
					<?/* ///// !!!!! */?>


				</td>
			</tr>
<?
$obDelivery = ob_get_contents();
ob_end_clean();

ob_start();
?>
			<tr>
				<td width="40%" align="right" class="field-name">
					<?=GetMessage("SOE_DELIVERY_COM") ?>:
				</td>
				<td width="60%">
					<div id="DELIVERY_ID_handler">
					<?
						$bUseDeliveryHandlers = true;
						echo $arDeliveryOrder["DELIVERY_AUTO"];
					?>
					</div>
				</td>
			</tr>
			<tr>
				<td width="40%" align="right" class="field-name">
					<?=GetMessage("SOE_DELIVERY_PRICE")?>:
				</td>
				<td width="60%">
						<?
						$result = array();
						if (!$bVarsFromForm)
						{
							$errorDeliverCalc = "";
							$result["VALUE"] = 0;
							$arParams = array(
								"ORDER_WEIGHT" => doubleval($productWeight),
								"ORDER_PRICE" => doubleval($str_PRICE-$str_PRICE_DELIVERY+$str_DISCOUNT_VALUE),
								"LOCATION_TO" => intval($DELIVERY_LOCATION),
								"LOCATION_ZIP" => $DELIVERY_LOCATION_ZIP,
								"CURRENCY" => $str_CURRENCY,
								"LID" => $LID
							);
							if (strpos($str_DELIVERY_ID, ':'))
							{
								list($DELIVERY_ID, $DELIVERY_PROFILE) = explode(":", $str_DELIVERY_ID);

								$arParams["DELIVERY"] = $DELIVERY_ID;
								$arParams["PROFILE"] = $DELIVERY_PROFILE;


								///// !!!!! -    eDost
								$arParams["PAY_SYSTEM_ID"] = $str_PAY_SYSTEM_ID;
								$arParams["PERSON_TYPE_ID"] = $str_PERSON_TYPE_ID;
								$arParams["BASKET_ITEMS"] = $arBasketItem;
								///// !!!!!


								$result = fGetAutoDelivery($arParams);

								if ($result["RESULT"] != "OK")
								{
									$result["VALUE"] = 0;
									$errorDeliverCalc = $result["TEXT"];
								}
							}
							if (doubleval($result["VALUE"]) != doubleval($str_PRICE_DELIVERY))
								$result["VALUE"] = roundEx($str_PRICE_DELIVERY, SALE_VALUE_PRECISION);
						}
						else
						{
							$result["VALUE"] = $PRICE_DELIVERY_handler;
						}
						?>


						<?/* ///// !!!!! -   delivery_price_new +   eDost */?>
						<?/*
				 		<input type="text" name="PRICE_DELIVERY_handler" onChange="fRecalProduct('', '');" value="<?=$result["VALUE"]?>" id="DELIVERY_ID_auto_text" />
						<div><?=$errorDeliverCalc?></div>
						*/?>
				 		<input type="text" name="PRICE_DELIVERY_handler" onChange="delivery_price_new = true; fRecalProduct('', '');" value="<?=$result["VALUE"]?>" id="DELIVERY_ID_auto_text" />
						<div id="errorDeliverCalc"><?=$errorDeliverCalc.(isset($arDeliveryOrder["delivery_error"]) ? '<font color="#FF0000"><b>'.$arDeliveryOrder["delivery_error"].'</b></font>' : '')?></div>
						<?/* ///// !!!!! */?>


						<script language="JavaScript">
						function fRecalcDeliveryAuto(value)
						{


							<?/* ///// !!!!! -   */?>
							fRecalcDelivery();
							return;
							<?/* ///// !!!!! */?>


							var buyerTypeID = document.getElementById("buyer_type_id").value;
							dateURL = '<?=CUtil::JSEscape(bitrix_sessid_get())?>&ORDER_AJAX=Y&LID=<?=$LID?>&persontypeid=' + buyerTypeID;
							BX.ajax.post('/bitrix/admin/sale_order_new.php', dateURL, fRecalcDeliveryResID);
						}
						function fRecalcDeliveryResID(result)
						{
							if (result.length > 0)
							{
								var res = eval( '('+result+')' );
								var value = document.getElementById('DELIVERY_ID_auto').value;

								delivery_id = "";
								profile_id = "";
								if (value != "")
								{
									var pos = value.indexOf(':');
									if (pos == -1) return;
									delivery_id = value.substring(0, pos);
									profile_id = value.substring(pos+1);
								}

								var locationZipID = "";
								var locationZIP = "";
								if (res["location_zip_id"] != "")
								{
									locationZipID = res["location_zip_id"];
									locationZIP = document.getElementById('ORDER_PROP_' + locationZipID).value;
								}

								var locationID = "";
								var location = "";
								if (res["location_id"] != "")
								{
									locationID = res["location_id"];
									location = document.getElementById('CITY_ORDER_PROP_' + locationID).value;
								}

								var orderCurrency = '<?=CUtil::JSEscape($arParams["CURRENCY"])?>';
								if (orderCurrency == "")
									orderCurrency = '<?=CUtil::JSEscape(CSaleLang::GetLangCurrency($LID))?>';

								urlData = "{'DELIVERY':'" +delivery_id+ "','PROFILE':'" +profile_id+ "','ORDER_WEIGHT':'" + orderWeight + "','ORDER_PRICE':'" + orderPrice + "','LOCATION_TO':'"+location+"','LOCATION_ZIP':'"+locationZIP+"','CURRENCY':'"+orderCurrency+"','LID':'<?=CUtil::JSEscape($arParams["LID"])?>','ID':'<?=$ID?>'}";

								BX.showWait();
								BX.ajax.post('/bitrix/admin/sale_order_new.php', '<?=CUtil::JSEscape(bitrix_sessid_get())?>&ORDER_AJAX=Y&recalcDeliverAuto=' + urlData, fRecalcDeliveryAutoResult);
							}

						}
						function fRecalcDeliveryAutoResult(result)
						{
							BX.closeWait();

							var res = eval( '('+result+')' );

							if (res["RESULT"] == "OK")
							{
								document.getElementById("DELIVERY_ID_auto_text").value = res["VALUE"];
							}
							else
							{
								document.getElementById("DELIVERY_ID_auto_text").value = '0';
							}
							fRecalProduct('', '');
						}
						</script>
				</td>
			</tr>
<?
$obDeliveryHandlers = ob_get_contents();
ob_end_clean();


if ($bUseDelivery)
	$aSubTabs[] = array("DIV" => "delivery", "TAB" => GetMessage('SOE_DELIVERY_TAB'), "ONSELECT" => 'document.forms.form_order_form.DELIVERY_type.value=\'\'');
if ($bUseDeliveryHandlers)
	$aSubTabs[] = array("DIV" => "delivery_handler", "TAB" => GetMessage('SOE_DELIVERY_HANDLER_TAB'), "ONSELECT" => 'document.forms.form_order_form.DELIVERY_type.value=\'handler\'');

$childTabControl = new CAdminViewTabControl("childTabControl", $aSubTabs);
?>

	<tr>
		<td colspan="2"><input type="hidden" name="DELIVERY_type" value="" />
	<?
		$childTabControl->Begin();

		if ($bUseDelivery)
		{
			// simple delivery services
			$childTabControl->BeginNextTab();
	?>
			<table width="100%" class="edit-table"><tr><?echo $obDelivery;?></tr></table>
	<?
		}

		if ($bUseDeliveryHandlers)
		{
			// automated delivery services
			$childTabControl->BeginNextTab();
	?>
			<table width="100%" class="edit-table"><tr><?echo $obDeliveryHandlers;?></tr></table>
	<?
		}

		$childTabControl->End();
	?>
		</td>
	</tr>
	<script type="text/javascript">
	jsUtils.addEvent(window, 'load', function(){<?=$childTabControl->name?>.SelectTab('delivery<?if (strstr($str_DELIVERY_ID, ':') !== false):?>_handler<?endif;?>')});
	</script>

<?

$tabControl->EndCustomField("DELIVWRY_SERVICE");


//TAB COMMENTS
$tabControl->BeginNextFormTab();

$tabControl->AddSection("ADDITIONAL", GetMessage("SOE_ADDITIONAL"));

$tabControl->AddTextField("ADDITIONAL_INFO", GetMessage("SOE_ADDITIONAL").":", $str_ADDITIONAL_INFO, array("cols" => "40", "rows" => "5"));

$tabControl->AddSection("COMMENT", GetMessage("SOE_COMMENT"));

$tabControl->AddTextField("COMMENTS", GetMessage("SOE_COMMENT").GetMessage("SOE_COMMENT_NOTE").":", $str_COMMENTS, array("cols" => "40", "rows" => "5"));

if (!defined('BX_PUBLIC_MODE') || BX_PUBLIC_MODE != 1)
{
	$tabControl->Buttons(array("back_url"=>"sale_order.php?lang=".LANGUAGE_ID));
}

$tabControl->Show();

require($DOCUMENT_ROOT."/bitrix/modules/main/include/epilog_admin.php");
?>
